/* BaseBus.c generated by valac 0.34.9, the Vala compiler
 * generated from BaseBus.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gio/gunixsocketaddress.h>


#define DRT_TYPE_BASE_BUS (drt_base_bus_get_type ())
#define DRT_BASE_BUS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_BASE_BUS, DrtBaseBus))
#define DRT_BASE_BUS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_BASE_BUS, DrtBaseBusClass))
#define DRT_IS_BASE_BUS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_BASE_BUS))
#define DRT_IS_BASE_BUS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_BASE_BUS))
#define DRT_BASE_BUS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_BASE_BUS, DrtBaseBusClass))

typedef struct _DrtBaseBus DrtBaseBus;
typedef struct _DrtBaseBusClass DrtBaseBusClass;
typedef struct _DrtBaseBusPrivate DrtBaseBusPrivate;

#define DRT_TYPE_BASE_CHANNEL (drt_base_channel_get_type ())
#define DRT_BASE_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_BASE_CHANNEL, DrtBaseChannel))
#define DRT_BASE_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_BASE_CHANNEL, DrtBaseChannelClass))
#define DRT_IS_BASE_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_BASE_CHANNEL))
#define DRT_IS_BASE_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_BASE_CHANNEL))
#define DRT_BASE_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_BASE_CHANNEL, DrtBaseChannelClass))

typedef struct _DrtBaseChannel DrtBaseChannel;
typedef struct _DrtBaseChannelClass DrtBaseChannelClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define DRT_TYPE_DUPLEX_CHANNEL (drt_duplex_channel_get_type ())
#define DRT_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannel))
#define DRT_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))
#define DRT_IS_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_IS_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_DUPLEX_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))

typedef struct _DrtDuplexChannel DrtDuplexChannel;
typedef struct _DrtDuplexChannelClass DrtDuplexChannelClass;

#define DRT_TYPE_SOCKET_CHANNEL (drt_socket_channel_get_type ())
#define DRT_SOCKET_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannel))
#define DRT_SOCKET_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannelClass))
#define DRT_IS_SOCKET_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_SOCKET_CHANNEL))
#define DRT_IS_SOCKET_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_SOCKET_CHANNEL))
#define DRT_SOCKET_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannelClass))

typedef struct _DrtSocketChannel DrtSocketChannel;
typedef struct _DrtSocketChannelClass DrtSocketChannelClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DrtBaseBus {
	GObject parent_instance;
	DrtBaseBusPrivate * priv;
	GObject* base_router;
	GHashTable* clients;
};

struct _DrtBaseBusClass {
	GObjectClass parent_class;
};

struct _DrtBaseBusPrivate {
	GType channeltype_type;
	GBoxedCopyFunc channeltype_dup_func;
	GDestroyNotify channeltype_destroy_func;
	GType routertype_type;
	GBoxedCopyFunc routertype_dup_func;
	GDestroyNotify routertype_destroy_func;
	guint _timeout;
	gchar* _name;
	gchar* path;
	GSocketService* service;
	guint last_client_id;
};

typedef enum  {
	DRT_IO_ERROR_CONN_FAILED,
	DRT_IO_ERROR_TIMEOUT,
	DRT_IO_ERROR_RW_FAILED,
	DRT_IO_ERROR_READ,
	DRT_IO_ERROR_WRITE,
	DRT_IO_ERROR_TOO_MANY_DATA,
	DRT_IO_ERROR_NOT_CONNECTED,
	DRT_IO_ERROR_OP_FAILED
} DrtIOError;
#define DRT_IO_ERROR drt_io_error_quark ()

static gpointer drt_base_bus_parent_class = NULL;

GType drt_base_bus_get_type (void) G_GNUC_CONST;
GType drt_base_channel_get_type (void) G_GNUC_CONST;
#define DRT_BASE_BUS_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_BASE_BUS, DrtBaseBusPrivate))
enum  {
	DRT_BASE_BUS_DUMMY_PROPERTY,
	DRT_BASE_BUS_CHANNELTYPE_TYPE,
	DRT_BASE_BUS_CHANNELTYPE_DUP_FUNC,
	DRT_BASE_BUS_CHANNELTYPE_DESTROY_FUNC,
	DRT_BASE_BUS_ROUTERTYPE_TYPE,
	DRT_BASE_BUS_ROUTERTYPE_DUP_FUNC,
	DRT_BASE_BUS_ROUTERTYPE_DESTROY_FUNC,
	DRT_BASE_BUS_ROUTER,
	DRT_BASE_BUS_TIMEOUT,
	DRT_BASE_BUS_NAME
};
DrtBaseBus* drt_base_bus_construct (GType object_type, GType channeltype_type, GBoxedCopyFunc channeltype_dup_func, GDestroyNotify channeltype_destroy_func, GType routertype_type, GBoxedCopyFunc routertype_dup_func, GDestroyNotify routertype_destroy_func, const gchar* name, GObject* router, guint timeout);
static void drt_base_bus_set_name (DrtBaseBus* self, const gchar* value);
void drt_base_bus_set_timeout (DrtBaseBus* self, guint value);
gchar* drt_ipc_create_path (const gchar* name);
static void _g_object_unref0_ (gpointer var);
GQuark drt_io_error_quark (void);
void drt_base_bus_start (DrtBaseBus* self, GError** error);
static void drt_base_bus_create_service (DrtBaseBus* self, GError** error);
gpointer drt_base_bus_connect_channel (DrtBaseBus* self, const gchar* name, guint timeout, GError** error);
guint drt_base_bus_get_next_client_id (DrtBaseBus* self);
GType drt_duplex_channel_get_type (void) G_GNUC_CONST;
GType drt_socket_channel_get_type (void) G_GNUC_CONST;
DrtSocketChannel* drt_socket_channel_new_from_name (guint id, const gchar* name, guint timeout, GError** error);
DrtSocketChannel* drt_socket_channel_construct_from_name (GType object_type, guint id, const gchar* name, guint timeout, GError** error);
gpointer drt_base_bus_connect_channel_socket (DrtBaseBus* self, GSocket* socket, guint timeout, GError** error);
DrtSocketChannel* drt_socket_channel_new_from_socket (guint id, GSocket* socket, guint timeout, GError** error);
DrtSocketChannel* drt_socket_channel_construct_from_socket (GType object_type, guint id, GSocket* socket, guint timeout, GError** error);
static gboolean drt_base_bus_on_incoming (DrtBaseBus* self, GSocketConnection* connection, GObject* source_object);
static gboolean _drt_base_bus_on_incoming_g_socket_service_incoming (GSocketService* _sender, GSocketConnection* connection, GObject* source_object, gpointer self);
guint drt_base_bus_get_timeout (DrtBaseBus* self);
DrtSocketChannel* drt_socket_channel_new (guint id, const gchar* name, GSocketConnection* connection, guint timeout);
DrtSocketChannel* drt_socket_channel_construct (GType object_type, guint id, const gchar* name, GSocketConnection* connection, guint timeout);
gconstpointer drt_base_bus_get_router (DrtBaseBus* self);
void drt_base_bus_on_channel_closed (DrtBaseBus* self, GObject* source, GParamSpec* param);
static void _drt_base_bus_on_channel_closed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
guint drt_base_channel_get_id (DrtBaseChannel* self);
const gchar* drt_base_bus_get_name (DrtBaseBus* self);
static void drt_base_bus_finalize (GObject* obj);
static void _vala_drt_base_bus_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_base_bus_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


DrtBaseBus* drt_base_bus_construct (GType object_type, GType channeltype_type, GBoxedCopyFunc channeltype_dup_func, GDestroyNotify channeltype_destroy_func, GType routertype_type, GBoxedCopyFunc routertype_dup_func, GDestroyNotify routertype_destroy_func, const gchar* name, GObject* router, guint timeout) {
	DrtBaseBus * self = NULL;
	const gchar* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GObject* _tmp4_ = NULL;
	GObject* _tmp5_ = NULL;
	GHashFunc _tmp6_ = NULL;
	GEqualFunc _tmp7_ = NULL;
	GHashTable* _tmp8_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (router != NULL, NULL);
	self = (DrtBaseBus*) g_object_new (object_type, NULL);
	self->priv->channeltype_type = channeltype_type;
	self->priv->channeltype_dup_func = channeltype_dup_func;
	self->priv->channeltype_destroy_func = channeltype_destroy_func;
	self->priv->routertype_type = routertype_type;
	self->priv->routertype_dup_func = routertype_dup_func;
	self->priv->routertype_destroy_func = routertype_destroy_func;
	_tmp0_ = name;
	drt_base_bus_set_name (self, _tmp0_);
	_tmp1_ = timeout;
	drt_base_bus_set_timeout (self, _tmp1_);
	_tmp2_ = name;
	_tmp3_ = drt_ipc_create_path (_tmp2_);
	_g_free0 (self->priv->path);
	self->priv->path = _tmp3_;
	_tmp4_ = router;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (self->base_router);
	self->base_router = _tmp5_;
	_tmp6_ = g_direct_hash;
	_tmp7_ = g_direct_equal;
	_tmp8_ = g_hash_table_new_full (_tmp6_, _tmp7_, NULL, _g_object_unref0_);
	_g_hash_table_unref0 (self->clients);
	self->clients = _tmp8_;
	return self;
}


void drt_base_bus_start (DrtBaseBus* self, GError** error) {
	GSocketService* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	drt_base_bus_create_service (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp0_ = self->priv->service;
	g_socket_service_start (_tmp0_);
}


gpointer drt_base_bus_connect_channel (DrtBaseBus* self, const gchar* name, guint timeout, GError** error) {
	gpointer result = NULL;
	guint id = 0U;
	guint _tmp0_ = 0U;
	DrtSocketChannel* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	DrtSocketChannel* _tmp4_ = NULL;
	DrtBaseChannel* channel = NULL;
	DrtSocketChannel* _tmp5_ = NULL;
	DrtSocketChannel* _tmp6_ = NULL;
	GObject* _tmp7_ = NULL;
	GObject* _tmp8_ = NULL;
	GObject* _tmp9_ = NULL;
	DrtBaseChannel* _tmp10_ = NULL;
	GHashTable* _tmp11_ = NULL;
	void* _tmp12_ = NULL;
	DrtBaseChannel* _tmp13_ = NULL;
	DrtBaseChannel* _tmp14_ = NULL;
	DrtBaseChannel* _tmp15_ = NULL;
	gpointer _tmp16_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = drt_base_bus_get_next_client_id (self);
	id = _tmp0_;
	_tmp2_ = name;
	_tmp3_ = timeout;
	_tmp4_ = drt_socket_channel_new_from_name (id, _tmp2_, _tmp3_, &_inner_error_);
	_tmp1_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = _tmp1_;
	_tmp1_ = NULL;
	_tmp6_ = _tmp5_;
	_tmp7_ = self->base_router;
	_tmp8_ = g_object_new (self->priv->channeltype_type, "id", id, "channel", _tmp6_, "router", _tmp7_, NULL);
	_tmp9_ = G_IS_INITIALLY_UNOWNED (_tmp8_) ? g_object_ref_sink (_tmp8_) : _tmp8_;
	_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, DRT_TYPE_BASE_CHANNEL, DrtBaseChannel);
	_g_object_unref0 (_tmp6_);
	channel = _tmp10_;
	_tmp11_ = self->clients;
	_tmp12_ = GUINT_TO_POINTER (id);
	_tmp13_ = channel;
	_tmp14_ = _g_object_ref0 (_tmp13_);
	g_hash_table_insert (_tmp11_, _tmp12_, _tmp14_);
	_tmp15_ = channel;
	_tmp16_ = ((((gconstpointer) _tmp15_) != NULL) && (self->priv->channeltype_dup_func != NULL)) ? self->priv->channeltype_dup_func ((gpointer) ((gconstpointer) _tmp15_)) : ((gpointer) ((gconstpointer) _tmp15_));
	result = _tmp16_;
	_g_object_unref0 (channel);
	_g_object_unref0 (_tmp1_);
	return result;
}


gpointer drt_base_bus_connect_channel_socket (DrtBaseBus* self, GSocket* socket, guint timeout, GError** error) {
	gpointer result = NULL;
	guint id = 0U;
	guint _tmp0_ = 0U;
	DrtSocketChannel* _tmp1_ = NULL;
	GSocket* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	DrtSocketChannel* _tmp4_ = NULL;
	DrtBaseChannel* channel = NULL;
	DrtSocketChannel* _tmp5_ = NULL;
	DrtSocketChannel* _tmp6_ = NULL;
	GObject* _tmp7_ = NULL;
	GObject* _tmp8_ = NULL;
	GObject* _tmp9_ = NULL;
	DrtBaseChannel* _tmp10_ = NULL;
	GHashTable* _tmp11_ = NULL;
	void* _tmp12_ = NULL;
	DrtBaseChannel* _tmp13_ = NULL;
	DrtBaseChannel* _tmp14_ = NULL;
	DrtBaseChannel* _tmp15_ = NULL;
	gpointer _tmp16_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (socket != NULL, NULL);
	_tmp0_ = drt_base_bus_get_next_client_id (self);
	id = _tmp0_;
	_tmp2_ = socket;
	_tmp3_ = timeout;
	_tmp4_ = drt_socket_channel_new_from_socket (id, _tmp2_, _tmp3_, &_inner_error_);
	_tmp1_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = _tmp1_;
	_tmp1_ = NULL;
	_tmp6_ = _tmp5_;
	_tmp7_ = self->base_router;
	_tmp8_ = g_object_new (self->priv->channeltype_type, "id", id, "channel", _tmp6_, "router", _tmp7_, NULL);
	_tmp9_ = G_IS_INITIALLY_UNOWNED (_tmp8_) ? g_object_ref_sink (_tmp8_) : _tmp8_;
	_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, DRT_TYPE_BASE_CHANNEL, DrtBaseChannel);
	_g_object_unref0 (_tmp6_);
	channel = _tmp10_;
	_tmp11_ = self->clients;
	_tmp12_ = GUINT_TO_POINTER (id);
	_tmp13_ = channel;
	_tmp14_ = _g_object_ref0 (_tmp13_);
	g_hash_table_insert (_tmp11_, _tmp12_, _tmp14_);
	_tmp15_ = channel;
	_tmp16_ = ((((gconstpointer) _tmp15_) != NULL) && (self->priv->channeltype_dup_func != NULL)) ? self->priv->channeltype_dup_func ((gpointer) ((gconstpointer) _tmp15_)) : ((gpointer) ((gconstpointer) _tmp15_));
	result = _tmp16_;
	_g_object_unref0 (channel);
	_g_object_unref0 (_tmp1_);
	return result;
}


static gboolean _drt_base_bus_on_incoming_g_socket_service_incoming (GSocketService* _sender, GSocketConnection* connection, GObject* source_object, gpointer self) {
	gboolean result;
	result = drt_base_bus_on_incoming ((DrtBaseBus*) self, connection, source_object);
	return result;
}


static void drt_base_bus_create_service (DrtBaseBus* self, GError** error) {
	GSocketService* _tmp0_ = NULL;
	GUnixSocketAddress* address = NULL;
	const gchar* _tmp4_ = NULL;
	GUnixSocketAddress* _tmp5_ = NULL;
	GSocketService* _tmp6_ = NULL;
	GSocketAddress* effective_address = NULL;
	GSocketService* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->service;
	if (_tmp0_ != NULL) {
		return;
	}
	{
		const gchar* _tmp1_ = NULL;
		GFile* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		_tmp1_ = self->priv->path;
		_tmp2_ = g_file_new_for_path (_tmp1_);
		_tmp3_ = _tmp2_;
		g_file_delete (_tmp3_, NULL, &_inner_error_);
		_g_object_unref0 (_tmp3_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp4_ = self->priv->path;
	_tmp5_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp4_);
	address = _tmp5_;
	_tmp6_ = g_socket_service_new ();
	_g_object_unref0 (self->priv->service);
	self->priv->service = _tmp6_;
	{
		GSocketService* _tmp7_ = NULL;
		GUnixSocketAddress* _tmp8_ = NULL;
		GSocketAddress* _tmp9_ = NULL;
		_tmp7_ = self->priv->service;
		_tmp8_ = address;
		g_socket_listener_add_address ((GSocketListener*) _tmp7_, (GSocketAddress*) _tmp8_, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, NULL, &_tmp9_, &_inner_error_);
		_g_object_unref0 (effective_address);
		effective_address = _tmp9_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp10_ = NULL;
		GError* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp10_ = self->priv->path;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		_tmp13_ = g_error_new (DRT_IO_ERROR, DRT_IO_ERROR_CONN_FAILED, "Failed to add socket '%s'. %s", _tmp10_, _tmp12_);
		_inner_error_ = _tmp13_;
		_g_error_free0 (e);
		goto __finally2;
	}
	__finally2:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (effective_address);
			_g_object_unref0 (address);
			return;
		} else {
			_g_object_unref0 (effective_address);
			_g_object_unref0 (address);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp14_ = self->priv->service;
	g_signal_connect_object (_tmp14_, "incoming", (GCallback) _drt_base_bus_on_incoming_g_socket_service_incoming, self, 0);
	_g_object_unref0 (effective_address);
	_g_object_unref0 (address);
}


guint drt_base_bus_get_next_client_id (DrtBaseBus* self) {
	guint result = 0U;
	guint id = 0U;
	guint _tmp0_ = 0U;
	GHashTable* _tmp8_ = NULL;
	guint _tmp9_ = 0U;
	void* _tmp10_ = NULL;
	guint _tmp11_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->last_client_id;
	id = _tmp0_;
	{
		gboolean _tmp1_ = FALSE;
		_tmp1_ = TRUE;
		while (TRUE) {
			guint _tmp6_ = 0U;
			if (!_tmp1_) {
				GHashTable* _tmp2_ = NULL;
				guint _tmp3_ = 0U;
				void* _tmp4_ = NULL;
				gboolean _tmp5_ = FALSE;
				_tmp2_ = self->clients;
				_tmp3_ = id;
				_tmp4_ = GUINT_TO_POINTER (_tmp3_);
				_tmp5_ = g_hash_table_contains (_tmp2_, _tmp4_);
				if (!_tmp5_) {
					break;
				}
			}
			_tmp1_ = FALSE;
			_tmp6_ = id;
			if (_tmp6_ == G_MAXUINT) {
				id = (guint) 1;
			} else {
				guint _tmp7_ = 0U;
				_tmp7_ = id;
				id = _tmp7_ + 1;
			}
		}
	}
	_tmp8_ = self->clients;
	_tmp9_ = id;
	_tmp10_ = GUINT_TO_POINTER (_tmp9_);
	g_hash_table_insert (_tmp8_, _tmp10_, NULL);
	_tmp11_ = id;
	self->priv->last_client_id = _tmp11_;
	result = id;
	return result;
}


static void _drt_base_bus_on_channel_closed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	drt_base_bus_on_channel_closed ((DrtBaseBus*) self, _sender, pspec);
}


static gboolean drt_base_bus_on_incoming (DrtBaseBus* self, GSocketConnection* connection, GObject* source_object) {
	gboolean result = FALSE;
	guint id = 0U;
	guint _tmp0_ = 0U;
	DrtBaseChannel* channel = NULL;
	const gchar* _tmp1_ = NULL;
	GSocketConnection* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	DrtSocketChannel* _tmp4_ = NULL;
	DrtSocketChannel* _tmp5_ = NULL;
	gconstpointer _tmp6_ = NULL;
	gconstpointer _tmp7_ = NULL;
	GObject* _tmp8_ = NULL;
	GObject* _tmp9_ = NULL;
	DrtBaseChannel* _tmp10_ = NULL;
	GHashTable* _tmp11_ = NULL;
	void* _tmp12_ = NULL;
	DrtBaseChannel* _tmp13_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (connection != NULL, FALSE);
	_tmp0_ = drt_base_bus_get_next_client_id (self);
	id = _tmp0_;
	_tmp1_ = self->priv->path;
	_tmp2_ = connection;
	_tmp3_ = self->priv->_timeout;
	_tmp4_ = drt_socket_channel_new (id, _tmp1_, _tmp2_, _tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = drt_base_bus_get_router (self);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_object_new (self->priv->channeltype_type, "id", id, "channel", _tmp5_, "router", _tmp7_, NULL);
	_tmp9_ = G_IS_INITIALLY_UNOWNED (_tmp8_) ? g_object_ref_sink (_tmp8_) : _tmp8_;
	_tmp10_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, DRT_TYPE_BASE_CHANNEL, DrtBaseChannel);
	_g_object_unref0 (_tmp5_);
	channel = _tmp10_;
	_tmp11_ = self->clients;
	_tmp12_ = GUINT_TO_POINTER (id);
	_tmp13_ = _g_object_ref0 (channel);
	g_hash_table_insert (_tmp11_, _tmp12_, _tmp13_);
	g_signal_connect_object ((GObject*) channel, "notify::closed", (GCallback) _drt_base_bus_on_channel_closed_g_object_notify, self, G_CONNECT_AFTER);
	g_signal_emit_by_name (self, "incoming", (gconstpointer) channel);
	result = TRUE;
	_g_object_unref0 (channel);
	return result;
}


void drt_base_bus_on_channel_closed (DrtBaseBus* self, GObject* source, GParamSpec* param) {
	DrtBaseChannel* channel = NULL;
	GObject* _tmp0_ = NULL;
	DrtBaseChannel* _tmp1_ = NULL;
	guint _tmp2_ = 0U;
	GQuark _tmp3_ = 0U;
	GHashTable* _tmp4_ = NULL;
	guint _tmp5_ = 0U;
	guint _tmp6_ = 0U;
	void* _tmp7_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (param != NULL);
	_tmp0_ = source;
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, DRT_TYPE_BASE_CHANNEL) ? ((DrtBaseChannel*) _tmp0_) : NULL);
	channel = _tmp1_;
	g_return_if_fail (channel != NULL);
	g_signal_parse_name ("notify::closed", G_TYPE_OBJECT, &_tmp2_, &_tmp3_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) channel, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, _tmp3_, NULL, (GCallback) _drt_base_bus_on_channel_closed_g_object_notify, self);
	_tmp4_ = self->clients;
	_tmp5_ = drt_base_channel_get_id (channel);
	_tmp6_ = _tmp5_;
	_tmp7_ = GUINT_TO_POINTER (_tmp6_);
	g_hash_table_remove (_tmp4_, _tmp7_);
	_g_object_unref0 (channel);
}


gconstpointer drt_base_bus_get_router (DrtBaseBus* self) {
	gconstpointer result;
	GObject* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->base_router;
	result = (gconstpointer) _tmp0_;
	return result;
}


guint drt_base_bus_get_timeout (DrtBaseBus* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = self->priv->_timeout;
	result = _tmp0_;
	return result;
}


void drt_base_bus_set_timeout (DrtBaseBus* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_timeout = _tmp0_;
	g_object_notify ((GObject *) self, "timeout");
}


const gchar* drt_base_bus_get_name (DrtBaseBus* self) {
	const gchar* result;
	const gchar* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_name;
	result = _tmp0_;
	return result;
}


static void drt_base_bus_set_name (DrtBaseBus* self, const gchar* value) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (self->priv->_name);
	self->priv->_name = _tmp1_;
	g_object_notify ((GObject *) self, "name");
}


static void drt_base_bus_class_init (DrtBaseBusClass * klass) {
	drt_base_bus_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtBaseBusPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_base_bus_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_base_bus_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_base_bus_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_CHANNELTYPE_TYPE, g_param_spec_gtype ("channeltype-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_CHANNELTYPE_DUP_FUNC, g_param_spec_pointer ("channeltype-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_CHANNELTYPE_DESTROY_FUNC, g_param_spec_pointer ("channeltype-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_ROUTERTYPE_TYPE, g_param_spec_gtype ("routertype-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_ROUTERTYPE_DUP_FUNC, g_param_spec_pointer ("routertype-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_ROUTERTYPE_DESTROY_FUNC, g_param_spec_pointer ("routertype-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_ROUTER, g_param_spec_pointer ("router", "router", "router", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_TIMEOUT, g_param_spec_uint ("timeout", "timeout", "timeout", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BASE_BUS_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_signal_new ("incoming", DRT_TYPE_BASE_BUS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
}


static void drt_base_bus_instance_init (DrtBaseBus * self) {
	self->priv = DRT_BASE_BUS_GET_PRIVATE (self);
	self->priv->service = NULL;
	self->clients = NULL;
	self->priv->last_client_id = (guint) 0;
}


static void drt_base_bus_finalize (GObject* obj) {
	DrtBaseBus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_BASE_BUS, DrtBaseBus);
	_g_object_unref0 (self->base_router);
	_g_free0 (self->priv->_name);
	_g_free0 (self->priv->path);
	_g_object_unref0 (self->priv->service);
	_g_hash_table_unref0 (self->clients);
	G_OBJECT_CLASS (drt_base_bus_parent_class)->finalize (obj);
}


GType drt_base_bus_get_type (void) {
	static volatile gsize drt_base_bus_type_id__volatile = 0;
	if (g_once_init_enter (&drt_base_bus_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtBaseBusClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_base_bus_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtBaseBus), 0, (GInstanceInitFunc) drt_base_bus_instance_init, NULL };
		GType drt_base_bus_type_id;
		drt_base_bus_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtBaseBus", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
		g_once_init_leave (&drt_base_bus_type_id__volatile, drt_base_bus_type_id);
	}
	return drt_base_bus_type_id__volatile;
}


static void _vala_drt_base_bus_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtBaseBus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BASE_BUS, DrtBaseBus);
	switch (property_id) {
		case DRT_BASE_BUS_ROUTER:
		g_value_set_pointer (value, drt_base_bus_get_router (self));
		break;
		case DRT_BASE_BUS_TIMEOUT:
		g_value_set_uint (value, drt_base_bus_get_timeout (self));
		break;
		case DRT_BASE_BUS_NAME:
		g_value_set_string (value, drt_base_bus_get_name (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_base_bus_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtBaseBus * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BASE_BUS, DrtBaseBus);
	switch (property_id) {
		case DRT_BASE_BUS_TIMEOUT:
		drt_base_bus_set_timeout (self, g_value_get_uint (value));
		break;
		case DRT_BASE_BUS_NAME:
		drt_base_bus_set_name (self, g_value_get_string (value));
		break;
		case DRT_BASE_BUS_CHANNELTYPE_TYPE:
		self->priv->channeltype_type = g_value_get_gtype (value);
		break;
		case DRT_BASE_BUS_CHANNELTYPE_DUP_FUNC:
		self->priv->channeltype_dup_func = g_value_get_pointer (value);
		break;
		case DRT_BASE_BUS_CHANNELTYPE_DESTROY_FUNC:
		self->priv->channeltype_destroy_func = g_value_get_pointer (value);
		break;
		case DRT_BASE_BUS_ROUTERTYPE_TYPE:
		self->priv->routertype_type = g_value_get_gtype (value);
		break;
		case DRT_BASE_BUS_ROUTERTYPE_DUP_FUNC:
		self->priv->routertype_dup_func = g_value_get_pointer (value);
		break;
		case DRT_BASE_BUS_ROUTERTYPE_DESTROY_FUNC:
		self->priv->routertype_destroy_func = g_value_get_pointer (value);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



