/* BluetoothChannel.c generated by valac 0.34.9, the Vala compiler
 * generated from BluetoothChannel.vala, do not modify */

/*
 * Copyright 2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>


#define DRT_TYPE_DUPLEX_CHANNEL (drt_duplex_channel_get_type ())
#define DRT_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannel))
#define DRT_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))
#define DRT_IS_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_IS_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_DUPLEX_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))

typedef struct _DrtDuplexChannel DrtDuplexChannel;
typedef struct _DrtDuplexChannelClass DrtDuplexChannelClass;
typedef struct _DrtDuplexChannelPrivate DrtDuplexChannelPrivate;

#define DRT_TYPE_BLUETOOTH_CHANNEL (drt_bluetooth_channel_get_type ())
#define DRT_BLUETOOTH_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_BLUETOOTH_CHANNEL, DrtBluetoothChannel))
#define DRT_BLUETOOTH_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_BLUETOOTH_CHANNEL, DrtBluetoothChannelClass))
#define DRT_IS_BLUETOOTH_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_BLUETOOTH_CHANNEL))
#define DRT_IS_BLUETOOTH_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_BLUETOOTH_CHANNEL))
#define DRT_BLUETOOTH_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_BLUETOOTH_CHANNEL, DrtBluetoothChannelClass))

typedef struct _DrtBluetoothChannel DrtBluetoothChannel;
typedef struct _DrtBluetoothChannelClass DrtBluetoothChannelClass;
typedef struct _DrtBluetoothChannelPrivate DrtBluetoothChannelPrivate;

#define DRT_TYPE_BLUETOOTH_CONNECTION (drt_bluetooth_connection_get_type ())
#define DRT_BLUETOOTH_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnection))
#define DRT_BLUETOOTH_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionClass))
#define DRT_IS_BLUETOOTH_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_BLUETOOTH_CONNECTION))
#define DRT_IS_BLUETOOTH_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_BLUETOOTH_CONNECTION))
#define DRT_BLUETOOTH_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_BLUETOOTH_CONNECTION, DrtBluetoothConnectionClass))

typedef struct _DrtBluetoothConnection DrtBluetoothConnection;
typedef struct _DrtBluetoothConnectionClass DrtBluetoothConnectionClass;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _DrtDuplexChannel {
	GObject parent_instance;
	DrtDuplexChannelPrivate * priv;
};

struct _DrtDuplexChannelClass {
	GObjectClass parent_class;
	void (*close) (DrtDuplexChannel* self, GError** error);
};

struct _DrtBluetoothChannel {
	DrtDuplexChannel parent_instance;
	DrtBluetoothChannelPrivate * priv;
};

struct _DrtBluetoothChannelClass {
	DrtDuplexChannelClass parent_class;
};

struct _DrtBluetoothChannelPrivate {
	DrtBluetoothConnection* _connection;
};


static gpointer drt_bluetooth_channel_parent_class = NULL;

GType drt_duplex_channel_get_type (void) G_GNUC_CONST;
GType drt_bluetooth_channel_get_type (void) G_GNUC_CONST;
GType drt_bluetooth_connection_get_type (void) G_GNUC_CONST;
#define DRT_BLUETOOTH_CHANNEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_BLUETOOTH_CHANNEL, DrtBluetoothChannelPrivate))
enum  {
	DRT_BLUETOOTH_CHANNEL_DUMMY_PROPERTY,
	DRT_BLUETOOTH_CHANNEL_CONNECTION
};
void drt_duplex_channel_close (DrtDuplexChannel* self, GError** error);
DrtBluetoothChannel* drt_bluetooth_channel_new (guint id, const gchar* name, DrtBluetoothConnection* connection, guint timeout);
DrtBluetoothChannel* drt_bluetooth_channel_construct (GType object_type, guint id, const gchar* name, DrtBluetoothConnection* connection, guint timeout);
GInputStream* drt_bluetooth_connection_get_input (DrtBluetoothConnection* self);
GOutputStream* drt_bluetooth_connection_get_output (DrtBluetoothConnection* self);
DrtDuplexChannel* drt_duplex_channel_construct (GType object_type, guint id, const gchar* name, GInputStream* input, GOutputStream* output, guint timeout);
static void drt_bluetooth_channel_set_connection (DrtBluetoothChannel* self, DrtBluetoothConnection* value);
static void drt_bluetooth_channel_real_close (DrtDuplexChannel* base, GError** error);
DrtBluetoothConnection* drt_bluetooth_channel_get_connection (DrtBluetoothChannel* self);
void drt_bluetooth_connection_close (DrtBluetoothConnection* self, GError** error);
static void drt_bluetooth_channel_finalize (GObject* obj);
static void _vala_drt_bluetooth_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_bluetooth_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


DrtBluetoothChannel* drt_bluetooth_channel_construct (GType object_type, guint id, const gchar* name, DrtBluetoothConnection* connection, guint timeout) {
	DrtBluetoothChannel * self = NULL;
	guint _tmp0_ = 0U;
	const gchar* _tmp1_ = NULL;
	DrtBluetoothConnection* _tmp2_ = NULL;
	GInputStream* _tmp3_ = NULL;
	GInputStream* _tmp4_ = NULL;
	DrtBluetoothConnection* _tmp5_ = NULL;
	GOutputStream* _tmp6_ = NULL;
	GOutputStream* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
	DrtBluetoothConnection* _tmp9_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (connection != NULL, NULL);
	_tmp0_ = id;
	_tmp1_ = name;
	_tmp2_ = connection;
	_tmp3_ = drt_bluetooth_connection_get_input (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = connection;
	_tmp6_ = drt_bluetooth_connection_get_output (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = timeout;
	self = (DrtBluetoothChannel*) drt_duplex_channel_construct (object_type, _tmp0_, _tmp1_, _tmp4_, _tmp7_, _tmp8_);
	_tmp9_ = connection;
	drt_bluetooth_channel_set_connection (self, _tmp9_);
	return self;
}


DrtBluetoothChannel* drt_bluetooth_channel_new (guint id, const gchar* name, DrtBluetoothConnection* connection, guint timeout) {
	return drt_bluetooth_channel_construct (DRT_TYPE_BLUETOOTH_CHANNEL, id, name, connection, timeout);
}


static void drt_bluetooth_channel_real_close (DrtDuplexChannel* base, GError** error) {
	DrtBluetoothChannel * self;
	DrtBluetoothConnection* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	self = (DrtBluetoothChannel*) base;
	_tmp0_ = self->priv->_connection;
	drt_bluetooth_connection_close (_tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


DrtBluetoothConnection* drt_bluetooth_channel_get_connection (DrtBluetoothChannel* self) {
	DrtBluetoothConnection* result;
	DrtBluetoothConnection* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_connection;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void drt_bluetooth_channel_set_connection (DrtBluetoothChannel* self, DrtBluetoothConnection* value) {
	DrtBluetoothConnection* _tmp0_ = NULL;
	DrtBluetoothConnection* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_connection);
	self->priv->_connection = _tmp1_;
	g_object_notify ((GObject *) self, "connection");
}


static void drt_bluetooth_channel_class_init (DrtBluetoothChannelClass * klass) {
	drt_bluetooth_channel_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtBluetoothChannelPrivate));
	((DrtDuplexChannelClass *) klass)->close = (void (*)(DrtDuplexChannel*, GError**)) drt_bluetooth_channel_real_close;
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_bluetooth_channel_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_bluetooth_channel_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_bluetooth_channel_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_BLUETOOTH_CHANNEL_CONNECTION, g_param_spec_object ("connection", "connection", "connection", DRT_TYPE_BLUETOOTH_CONNECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void drt_bluetooth_channel_instance_init (DrtBluetoothChannel * self) {
	self->priv = DRT_BLUETOOTH_CHANNEL_GET_PRIVATE (self);
}


static void drt_bluetooth_channel_finalize (GObject* obj) {
	DrtBluetoothChannel * self;
	GError * _inner_error_ = NULL;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_BLUETOOTH_CHANNEL, DrtBluetoothChannel);
	{
		drt_duplex_channel_close ((DrtDuplexChannel*) self, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch3_g_error;
		}
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (e);
	}
	__finally3:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_g_object_unref0 (self->priv->_connection);
	G_OBJECT_CLASS (drt_bluetooth_channel_parent_class)->finalize (obj);
}


GType drt_bluetooth_channel_get_type (void) {
	static volatile gsize drt_bluetooth_channel_type_id__volatile = 0;
	if (g_once_init_enter (&drt_bluetooth_channel_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtBluetoothChannelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_bluetooth_channel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtBluetoothChannel), 0, (GInstanceInitFunc) drt_bluetooth_channel_instance_init, NULL };
		GType drt_bluetooth_channel_type_id;
		drt_bluetooth_channel_type_id = g_type_register_static (DRT_TYPE_DUPLEX_CHANNEL, "DrtBluetoothChannel", &g_define_type_info, 0);
		g_once_init_leave (&drt_bluetooth_channel_type_id__volatile, drt_bluetooth_channel_type_id);
	}
	return drt_bluetooth_channel_type_id__volatile;
}


static void _vala_drt_bluetooth_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtBluetoothChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BLUETOOTH_CHANNEL, DrtBluetoothChannel);
	switch (property_id) {
		case DRT_BLUETOOTH_CHANNEL_CONNECTION:
		g_value_set_object (value, drt_bluetooth_channel_get_connection (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_bluetooth_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtBluetoothChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_BLUETOOTH_CHANNEL, DrtBluetoothChannel);
	switch (property_id) {
		case DRT_BLUETOOTH_CHANNEL_CONNECTION:
		drt_bluetooth_channel_set_connection (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



