/* ObjectSpec.c generated by valac 0.34.9, the Vala compiler
 * generated from ObjectSpec.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define DRTDB_TYPE_OBJECT_SPEC (drtdb_object_spec_get_type ())
#define DRTDB_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpec))
#define DRTDB_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpecClass))
#define DRTDB_IS_OBJECT_SPEC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_OBJECT_SPEC))
#define DRTDB_IS_OBJECT_SPEC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_OBJECT_SPEC))
#define DRTDB_OBJECT_SPEC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpecClass))

typedef struct _DrtdbObjectSpec DrtdbObjectSpec;
typedef struct _DrtdbObjectSpecClass DrtdbObjectSpecClass;
typedef struct _DrtdbObjectSpecPrivate DrtdbObjectSpecPrivate;
#define _drtdb_object_spec_unref0(var) ((var == NULL) ? NULL : (var = (drtdb_object_spec_unref (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))
#define _g_type_class_unref0(var) ((var == NULL) ? NULL : (var = (g_type_class_unref (var), NULL)))
typedef struct _DrtdbParamSpecObjectSpec DrtdbParamSpecObjectSpec;

struct _DrtdbObjectSpec {
	GTypeInstance parent_instance;
	volatile int ref_count;
	DrtdbObjectSpecPrivate * priv;
};

struct _DrtdbObjectSpecClass {
	GTypeClass parent_class;
	void (*finalize) (DrtdbObjectSpec *self);
};

struct _DrtdbObjectSpecPrivate {
	GType _object_type;
	GParamSpec* _primary_key;
	GParamSpec** _properties;
	gint _properties_length1;
	gint __properties_size_;
};

typedef enum  {
	DRTDB_DATABASE_ERROR_UNKNOWN,
	DRTDB_DATABASE_ERROR_IOERROR,
	DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DRTDB_DATABASE_ERROR_GENERAL,
	DRTDB_DATABASE_ERROR_RANGE,
	DRTDB_DATABASE_ERROR_DATA_TYPE,
	DRTDB_DATABASE_ERROR_NAME,
	DRTDB_DATABASE_ERROR_MISMATCH,
	DRTDB_DATABASE_ERROR_MISUSE,
	DRTDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DRTDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DrtdbDatabaseError;
#define DRTDB_DATABASE_ERROR drtdb_database_error_quark ()
struct _DrtdbParamSpecObjectSpec {
	GParamSpec parent_instance;
};


static gpointer drtdb_object_spec_parent_class = NULL;

gpointer drtdb_object_spec_ref (gpointer instance);
void drtdb_object_spec_unref (gpointer instance);
GParamSpec* drtdb_param_spec_object_spec (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void drtdb_value_set_object_spec (GValue* value, gpointer v_object);
void drtdb_value_take_object_spec (GValue* value, gpointer v_object);
gpointer drtdb_value_get_object_spec (const GValue* value);
GType drtdb_object_spec_get_type (void) G_GNUC_CONST;
#define DRTDB_OBJECT_SPEC_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpecPrivate))
enum  {
	DRTDB_OBJECT_SPEC_DUMMY_PROPERTY
};
GQuark drtdb_database_error_quark (void);
DrtdbObjectSpec* drtdb_object_spec_new (GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error);
DrtdbObjectSpec* drtdb_object_spec_construct (GType object_type, GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error);
GParamSpec** drtdb_create_param_spec_list (GObjectClass* class_spec, gchar** properties, int properties_length1, int* result_length1, GError** error);
DrtdbObjectSpec* drtdb_object_spec_new_with_pspecs (GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error);
DrtdbObjectSpec* drtdb_object_spec_construct_with_pspecs (GType object_type, GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error);
static void drtdb_object_spec_set_object_type (DrtdbObjectSpec* self, GType value);
static void drtdb_object_spec_set_properties (DrtdbObjectSpec* self, GParamSpec** value, int value_length1);
static void drtdb_object_spec_set_primary_key (DrtdbObjectSpec* self, GParamSpec* value);
GType drtdb_object_spec_get_object_type (DrtdbObjectSpec* self);
const gchar* drtdb_object_spec_get_table_name (DrtdbObjectSpec* self);
GParamSpec* drtdb_object_spec_get_primary_key (DrtdbObjectSpec* self);
GParamSpec** drtdb_object_spec_get_properties (DrtdbObjectSpec* self, int* result_length1);
static GParamSpec** _vala_array_dup1 (GParamSpec** self, int length);
static void drtdb_object_spec_finalize (DrtdbObjectSpec* obj);


/**
 * Creates new ORM object specification
 * 
 * @param type           object type
 * @param primary_key    primary key of the corresponding database table
 * @param properties     properties to serialize into database
 * @throws DatabaseError if data type is invalid or primary key is not found
 */
static gpointer _g_param_spec_ref0 (gpointer self) {
	return self ? g_param_spec_ref (self) : NULL;
}


DrtdbObjectSpec* drtdb_object_spec_construct (GType object_type, GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error) {
	DrtdbObjectSpec* self = NULL;
	GType _tmp0_ = 0UL;
	gboolean _tmp1_ = FALSE;
	GObjectClass* class_spec = NULL;
	GType _tmp5_ = 0UL;
	GTypeClass* _tmp6_ = NULL;
	GParamSpec* primary_pspec = NULL;
	GObjectClass* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	GParamSpec* _tmp9_ = NULL;
	GParamSpec* _tmp10_ = NULL;
	GParamSpec* _tmp11_ = NULL;
	GParamSpec** _tmp14_ = NULL;
	GObjectClass* _tmp15_ = NULL;
	gchar** _tmp16_ = NULL;
	gint _tmp16__length1 = 0;
	gint _tmp17_ = 0;
	GParamSpec** _tmp18_ = NULL;
	gint _tmp14__length1 = 0;
	gint __tmp14__size_ = 0;
	GType _tmp19_ = 0UL;
	GParamSpec* _tmp20_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (primary_key != NULL, NULL);
	_tmp0_ = type;
	_tmp1_ = G_TYPE_IS_OBJECT (_tmp0_);
	if (!_tmp1_) {
		GType _tmp2_ = 0UL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		_tmp2_ = type;
		_tmp3_ = g_type_name (_tmp2_);
		_tmp4_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp3_);
		_inner_error_ = _tmp4_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_drtdb_object_spec_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = type;
	_tmp6_ = g_type_class_ref (_tmp5_);
	class_spec = (GObjectClass*) _tmp6_;
	_tmp7_ = class_spec;
	_tmp8_ = primary_key;
	_tmp9_ = g_object_class_find_property (_tmp7_, _tmp8_);
	_tmp10_ = _g_param_spec_ref0 (_tmp9_);
	primary_pspec = _tmp10_;
	_tmp11_ = primary_pspec;
	if (_tmp11_ == NULL) {
		const gchar* _tmp12_ = NULL;
		GError* _tmp13_ = NULL;
		_tmp12_ = primary_key;
		_tmp13_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_NAME, "There is no property named '%s'.", _tmp12_);
		_inner_error_ = _tmp13_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_param_spec_unref0 (primary_pspec);
			_g_type_class_unref0 (class_spec);
			_drtdb_object_spec_unref0 (self);
			return NULL;
		} else {
			_g_param_spec_unref0 (primary_pspec);
			_g_type_class_unref0 (class_spec);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp15_ = class_spec;
	_tmp16_ = properties;
	_tmp16__length1 = properties_length1;
	_tmp18_ = drtdb_create_param_spec_list (_tmp15_, _tmp16_, _tmp16__length1, &_tmp17_, &_inner_error_);
	_tmp14_ = _tmp18_;
	_tmp14__length1 = _tmp17_;
	__tmp14__size_ = _tmp14__length1;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_param_spec_unref0 (primary_pspec);
			_g_type_class_unref0 (class_spec);
			_drtdb_object_spec_unref0 (self);
			return NULL;
		} else {
			_g_param_spec_unref0 (primary_pspec);
			_g_type_class_unref0 (class_spec);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp19_ = type;
	_tmp20_ = primary_pspec;
	self = (DrtdbObjectSpec*) drtdb_object_spec_construct_with_pspecs (object_type, _tmp19_, _tmp20_, _tmp14_, _tmp14__length1, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_tmp14_ = (g_free (_tmp14_), NULL);
			_g_param_spec_unref0 (primary_pspec);
			_g_type_class_unref0 (class_spec);
			_drtdb_object_spec_unref0 (self);
			return NULL;
		} else {
			_tmp14_ = (g_free (_tmp14_), NULL);
			_g_param_spec_unref0 (primary_pspec);
			_g_type_class_unref0 (class_spec);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp14_ = (g_free (_tmp14_), NULL);
	_g_param_spec_unref0 (primary_pspec);
	_g_type_class_unref0 (class_spec);
	return self;
}


DrtdbObjectSpec* drtdb_object_spec_new (GType type, const gchar* primary_key, gchar** properties, int properties_length1, GError** error) {
	return drtdb_object_spec_construct (DRTDB_TYPE_OBJECT_SPEC, type, primary_key, properties, properties_length1, error);
}


/**
 * Creates new ORM object specification
 * 
 * @param type           object type
 * @param primary_key    primary key of the corresponding database table
 * @param properties     properties to serialize into database
 * @throws DatabaseError if data type is invalid or primary key is not found
 */
DrtdbObjectSpec* drtdb_object_spec_construct_with_pspecs (GType object_type, GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error) {
	DrtdbObjectSpec* self = NULL;
	GType _tmp0_ = 0UL;
	gboolean _tmp1_ = FALSE;
	GType _tmp5_ = 0UL;
	GParamSpec** _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	GParamSpec* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (primary_key != NULL, NULL);
	self = (DrtdbObjectSpec*) g_type_create_instance (object_type);
	_tmp0_ = type;
	_tmp1_ = G_TYPE_IS_OBJECT (_tmp0_);
	if (!_tmp1_) {
		GType _tmp2_ = 0UL;
		const gchar* _tmp3_ = NULL;
		GError* _tmp4_ = NULL;
		_tmp2_ = type;
		_tmp3_ = g_type_name (_tmp2_);
		_tmp4_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp3_);
		_inner_error_ = _tmp4_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			_drtdb_object_spec_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = type;
	drtdb_object_spec_set_object_type (self, _tmp5_);
	_tmp6_ = properties;
	_tmp6__length1 = properties_length1;
	drtdb_object_spec_set_properties (self, _tmp6_, _tmp6__length1);
	_tmp7_ = primary_key;
	drtdb_object_spec_set_primary_key (self, _tmp7_);
	return self;
}


DrtdbObjectSpec* drtdb_object_spec_new_with_pspecs (GType type, GParamSpec* primary_key, GParamSpec** properties, int properties_length1, GError** error) {
	return drtdb_object_spec_construct_with_pspecs (DRTDB_TYPE_OBJECT_SPEC, type, primary_key, properties, properties_length1, error);
}


GType drtdb_object_spec_get_object_type (DrtdbObjectSpec* self) {
	GType result;
	GType _tmp0_ = 0UL;
	g_return_val_if_fail (self != NULL, 0UL);
	_tmp0_ = self->priv->_object_type;
	result = _tmp0_;
	return result;
}


static void drtdb_object_spec_set_object_type (DrtdbObjectSpec* self, GType value) {
	GType _tmp0_ = 0UL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_object_type = _tmp0_;
}


const gchar* drtdb_object_spec_get_table_name (DrtdbObjectSpec* self) {
	const gchar* result;
	GType _tmp0_ = 0UL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_object_type;
	_tmp1_ = g_type_name (_tmp0_);
	result = _tmp1_;
	return result;
}


GParamSpec* drtdb_object_spec_get_primary_key (DrtdbObjectSpec* self) {
	GParamSpec* result;
	GParamSpec* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_primary_key;
	result = _tmp0_;
	return result;
}


static void drtdb_object_spec_set_primary_key (DrtdbObjectSpec* self, GParamSpec* value) {
	GParamSpec* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_primary_key = _tmp0_;
}


GParamSpec** drtdb_object_spec_get_properties (DrtdbObjectSpec* self, int* result_length1) {
	GParamSpec** result;
	GParamSpec** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GParamSpec** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_properties;
	_tmp0__length1 = self->priv->_properties_length1;
	_tmp1_ = _tmp0_;
	_tmp1__length1 = _tmp0__length1;
	if (result_length1) {
		*result_length1 = _tmp1__length1;
	}
	result = _tmp1_;
	return result;
}


static GParamSpec** _vala_array_dup1 (GParamSpec** self, int length) {
	return g_memdup (self, length * sizeof (GParamSpec*));
}


static void drtdb_object_spec_set_properties (DrtdbObjectSpec* self, GParamSpec** value, int value_length1) {
	GParamSpec** _tmp0_ = NULL;
	gint _tmp0__length1 = 0;
	GParamSpec** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__length1 = value_length1;
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup1 (_tmp0_, _tmp0__length1) : ((gpointer) _tmp0_);
	_tmp1__length1 = _tmp0__length1;
	self->priv->_properties = (g_free (self->priv->_properties), NULL);
	self->priv->_properties = _tmp1_;
	self->priv->_properties_length1 = _tmp1__length1;
	self->priv->__properties_size_ = self->priv->_properties_length1;
}


static void drtdb_value_object_spec_init (GValue* value) {
	value->data[0].v_pointer = NULL;
}


static void drtdb_value_object_spec_free_value (GValue* value) {
	if (value->data[0].v_pointer) {
		drtdb_object_spec_unref (value->data[0].v_pointer);
	}
}


static void drtdb_value_object_spec_copy_value (const GValue* src_value, GValue* dest_value) {
	if (src_value->data[0].v_pointer) {
		dest_value->data[0].v_pointer = drtdb_object_spec_ref (src_value->data[0].v_pointer);
	} else {
		dest_value->data[0].v_pointer = NULL;
	}
}


static gpointer drtdb_value_object_spec_peek_pointer (const GValue* value) {
	return value->data[0].v_pointer;
}


static gchar* drtdb_value_object_spec_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	if (collect_values[0].v_pointer) {
		DrtdbObjectSpec* object;
		object = collect_values[0].v_pointer;
		if (object->parent_instance.g_class == NULL) {
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
		}
		value->data[0].v_pointer = drtdb_object_spec_ref (object);
	} else {
		value->data[0].v_pointer = NULL;
	}
	return NULL;
}


static gchar* drtdb_value_object_spec_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	DrtdbObjectSpec** object_p;
	object_p = collect_values[0].v_pointer;
	if (!object_p) {
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
	}
	if (!value->data[0].v_pointer) {
		*object_p = NULL;
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
		*object_p = value->data[0].v_pointer;
	} else {
		*object_p = drtdb_object_spec_ref (value->data[0].v_pointer);
	}
	return NULL;
}


GParamSpec* drtdb_param_spec_object_spec (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	DrtdbParamSpecObjectSpec* spec;
	g_return_val_if_fail (g_type_is_a (object_type, DRTDB_TYPE_OBJECT_SPEC), NULL);
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
	G_PARAM_SPEC (spec)->value_type = object_type;
	return G_PARAM_SPEC (spec);
}


gpointer drtdb_value_get_object_spec (const GValue* value) {
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRTDB_TYPE_OBJECT_SPEC), NULL);
	return value->data[0].v_pointer;
}


void drtdb_value_set_object_spec (GValue* value, gpointer v_object) {
	DrtdbObjectSpec* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRTDB_TYPE_OBJECT_SPEC));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRTDB_TYPE_OBJECT_SPEC));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
		drtdb_object_spec_ref (value->data[0].v_pointer);
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drtdb_object_spec_unref (old);
	}
}


void drtdb_value_take_object_spec (GValue* value, gpointer v_object) {
	DrtdbObjectSpec* old;
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, DRTDB_TYPE_OBJECT_SPEC));
	old = value->data[0].v_pointer;
	if (v_object) {
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, DRTDB_TYPE_OBJECT_SPEC));
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
		value->data[0].v_pointer = v_object;
	} else {
		value->data[0].v_pointer = NULL;
	}
	if (old) {
		drtdb_object_spec_unref (old);
	}
}


static void drtdb_object_spec_class_init (DrtdbObjectSpecClass * klass) {
	drtdb_object_spec_parent_class = g_type_class_peek_parent (klass);
	((DrtdbObjectSpecClass *) klass)->finalize = drtdb_object_spec_finalize;
	g_type_class_add_private (klass, sizeof (DrtdbObjectSpecPrivate));
}


static void drtdb_object_spec_instance_init (DrtdbObjectSpec * self) {
	self->priv = DRTDB_OBJECT_SPEC_GET_PRIVATE (self);
	self->ref_count = 1;
}


static void drtdb_object_spec_finalize (DrtdbObjectSpec* obj) {
	DrtdbObjectSpec * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRTDB_TYPE_OBJECT_SPEC, DrtdbObjectSpec);
	g_signal_handlers_destroy (self);
	self->priv->_properties = (g_free (self->priv->_properties), NULL);
}


/**
 * ORM object specification
 */
GType drtdb_object_spec_get_type (void) {
	static volatile gsize drtdb_object_spec_type_id__volatile = 0;
	if (g_once_init_enter (&drtdb_object_spec_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { drtdb_value_object_spec_init, drtdb_value_object_spec_free_value, drtdb_value_object_spec_copy_value, drtdb_value_object_spec_peek_pointer, "p", drtdb_value_object_spec_collect_value, "p", drtdb_value_object_spec_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (DrtdbObjectSpecClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drtdb_object_spec_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtdbObjectSpec), 0, (GInstanceInitFunc) drtdb_object_spec_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType drtdb_object_spec_type_id;
		drtdb_object_spec_type_id = g_type_register_fundamental (g_type_fundamental_next (), "DrtdbObjectSpec", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&drtdb_object_spec_type_id__volatile, drtdb_object_spec_type_id);
	}
	return drtdb_object_spec_type_id__volatile;
}


gpointer drtdb_object_spec_ref (gpointer instance) {
	DrtdbObjectSpec* self;
	self = instance;
	g_atomic_int_inc (&self->ref_count);
	return instance;
}


void drtdb_object_spec_unref (gpointer instance) {
	DrtdbObjectSpec* self;
	self = instance;
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
		DRTDB_OBJECT_SPEC_GET_CLASS (self)->finalize (self);
		g_type_free_instance ((GTypeInstance *) self);
	}
}



