/* Query.c generated by valac 0.34.9, the Vala compiler
 * generated from Query.vala, do not modify */

/*
 * Copyright 2015-2017 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <sqlite3.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>


#define DRTDB_TYPE_QUERY (drtdb_query_get_type ())
#define DRTDB_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_QUERY, DrtdbQuery))
#define DRTDB_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_QUERY, DrtdbQueryClass))
#define DRTDB_IS_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_QUERY))
#define DRTDB_IS_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_QUERY))
#define DRTDB_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_QUERY, DrtdbQueryClass))

typedef struct _DrtdbQuery DrtdbQuery;
typedef struct _DrtdbQueryClass DrtdbQueryClass;
typedef struct _DrtdbQueryPrivate DrtdbQueryPrivate;

#define DRTDB_TYPE_CONNECTION (drtdb_connection_get_type ())
#define DRTDB_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_CONNECTION, DrtdbConnection))
#define DRTDB_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_CONNECTION, DrtdbConnectionClass))
#define DRTDB_IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_CONNECTION))
#define DRTDB_IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_CONNECTION))
#define DRTDB_CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_CONNECTION, DrtdbConnectionClass))

typedef struct _DrtdbConnection DrtdbConnection;
typedef struct _DrtdbConnectionClass DrtdbConnectionClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

#define DRTDB_TYPE_RESULT (drtdb_result_get_type ())
#define DRTDB_RESULT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_RESULT, DrtdbResult))
#define DRTDB_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_RESULT, DrtdbResultClass))
#define DRTDB_IS_RESULT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_RESULT))
#define DRTDB_IS_RESULT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_RESULT))
#define DRTDB_RESULT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_RESULT, DrtdbResultClass))

typedef struct _DrtdbResult DrtdbResult;
typedef struct _DrtdbResultClass DrtdbResultClass;

#define DRTDB_TYPE_QUERYABLE (drtdb_queryable_get_type ())
#define DRTDB_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_QUERYABLE, DrtdbQueryable))
#define DRTDB_IS_QUERYABLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_QUERYABLE))
#define DRTDB_QUERYABLE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DRTDB_TYPE_QUERYABLE, DrtdbQueryableIface))

typedef struct _DrtdbQueryable DrtdbQueryable;
typedef struct _DrtdbQueryableIface DrtdbQueryableIface;

#define DRTDB_TYPE_OBJECT_QUERY (drtdb_object_query_get_type ())
#define DRTDB_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQuery))
#define DRTDB_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQueryClass))
#define DRTDB_IS_OBJECT_QUERY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRTDB_TYPE_OBJECT_QUERY))
#define DRTDB_IS_OBJECT_QUERY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRTDB_TYPE_OBJECT_QUERY))
#define DRTDB_OBJECT_QUERY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRTDB_TYPE_OBJECT_QUERY, DrtdbObjectQueryClass))

typedef struct _DrtdbObjectQuery DrtdbObjectQuery;
typedef struct _DrtdbObjectQueryClass DrtdbObjectQueryClass;

struct _DrtdbQuery {
	GObject parent_instance;
	DrtdbQueryPrivate * priv;
	gint n_parameters;
};

struct _DrtdbQueryClass {
	GObjectClass parent_class;
};

struct _DrtdbQueryPrivate {
	DrtdbConnection* _connection;
	sqlite3_stmt* statement;
};

typedef enum  {
	DRTDB_DATABASE_ERROR_UNKNOWN,
	DRTDB_DATABASE_ERROR_IOERROR,
	DRTDB_DATABASE_ERROR_DATABASE_NOT_OPENED,
	DRTDB_DATABASE_ERROR_GENERAL,
	DRTDB_DATABASE_ERROR_RANGE,
	DRTDB_DATABASE_ERROR_DATA_TYPE,
	DRTDB_DATABASE_ERROR_NAME,
	DRTDB_DATABASE_ERROR_MISMATCH,
	DRTDB_DATABASE_ERROR_MISUSE,
	DRTDB_DATABASE_ERROR_DOES_NOT_EXIST,
	DRTDB_DATABASE_ERROR_TOO_MANY_RESULTS
} DrtdbDatabaseError;
#define DRTDB_DATABASE_ERROR drtdb_database_error_quark ()
struct _DrtdbQueryableIface {
	GTypeInterface parent_iface;
	void (*exec) (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DrtdbQuery* (*query) (DrtdbQueryable* self, const gchar* sql, GCancellable* cancellable, GError** error);
	DrtdbObjectQuery* (*get_objects) (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GCancellable* cancellable, GError** error);
	gpointer (*get_object) (DrtdbQueryable* self, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func, GValue* pk, GCancellable* cancellable, GError** error);
	const gchar* (*get_last_error_message) (DrtdbQueryable* self);
};


static gpointer drtdb_query_parent_class = NULL;

GType drtdb_query_get_type (void) G_GNUC_CONST;
GType drtdb_connection_get_type (void) G_GNUC_CONST;
#define DRTDB_QUERY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRTDB_TYPE_QUERY, DrtdbQueryPrivate))
enum  {
	DRTDB_QUERY_DUMMY_PROPERTY,
	DRTDB_QUERY_CONNECTION
};
DrtdbQuery* drtdb_query_new (DrtdbConnection* connection, sqlite3_stmt* statement);
DrtdbQuery* drtdb_query_construct (GType object_type, DrtdbConnection* connection, sqlite3_stmt* statement);
static void drtdb_query_set_connection (DrtdbQuery* self, DrtdbConnection* value);
GType drtdb_result_get_type (void) G_GNUC_CONST;
GQuark drtdb_database_error_quark (void);
DrtdbResult* drtdb_query_exec (DrtdbQuery* self, GCancellable* cancellable, GError** error);
DrtdbResult* drtdb_query_get_result (DrtdbQuery* self, GError** error);
gboolean drtdb_result_next (DrtdbResult* self, GCancellable* cancellable, GError** error);
DrtdbResult* drtdb_query_select (DrtdbQuery* self, GCancellable* cancellable, GError** error);
void drtdb_query_check_not_executed (DrtdbQuery* self, GError** error);
DrtdbConnection* drtdb_query_get_connection (DrtdbQuery* self);
DrtdbResult* drtdb_result_new (DrtdbConnection* connection, sqlite3_stmt* statement);
DrtdbResult* drtdb_result_construct (GType object_type, DrtdbConnection* connection, sqlite3_stmt* statement);
DrtdbQuery* drtdb_query_bind_values (DrtdbQuery* self, gint index, GSList* values, GError** error);
DrtdbQuery* drtdb_query_bind (DrtdbQuery* self, gint index, GValue* value, GError** error);
DrtdbQuery* drtdb_query_bind_null (DrtdbQuery* self, gint index, GError** error);
DrtdbQuery* drtdb_query_bind_bool (DrtdbQuery* self, gint index, gboolean value, GError** error);
DrtdbQuery* drtdb_query_bind_int (DrtdbQuery* self, gint index, gint value, GError** error);
DrtdbQuery* drtdb_query_bind_int64 (DrtdbQuery* self, gint index, gint64 value, GError** error);
DrtdbQuery* drtdb_query_bind_string (DrtdbQuery* self, gint index, const gchar* value, GError** error);
DrtdbQuery* drtdb_query_bind_double (DrtdbQuery* self, gint index, gdouble value, GError** error);
DrtdbQuery* drtdb_query_bind_bytes (DrtdbQuery* self, gint index, GBytes* value, GError** error);
DrtdbQuery* drtdb_query_bind_byte_array (DrtdbQuery* self, gint index, GByteArray* value, GError** error);
gint drtdb_query_check_index (DrtdbQuery* self, gint index, GError** error);
gint drtdb_query_throw_on_error (DrtdbQuery* self, gint _result_, const gchar* sql, GError** error);
DrtdbQuery* drtdb_query_bind_blob (DrtdbQuery* self, gint index, guint8* value, int value_length1, GError** error);
gboolean drtdb_is_sql_error (gint result_code);
GError* drtdb_convert_sqlite_error (gint errno, const gchar* message, const gchar* sql, sqlite3_stmt* stm);
GType drtdb_object_query_get_type (void) G_GNUC_CONST;
GType drtdb_queryable_get_type (void) G_GNUC_CONST;
const gchar* drtdb_queryable_get_last_error_message (DrtdbQueryable* self);
static void drtdb_query_finalize (GObject* obj);
static void _vala_drtdb_query_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drtdb_query_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


/**
 * Create new database query wrapper
 * 
 * @param connection      corresponding database connection
 * @param statement       corresponding sql query
 */
DrtdbQuery* drtdb_query_construct (GType object_type, DrtdbConnection* connection, sqlite3_stmt* statement) {
	DrtdbQuery * self = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	sqlite3_stmt* _tmp1_ = NULL;
	sqlite3_stmt* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	g_return_val_if_fail (connection != NULL, NULL);
	g_return_val_if_fail (statement != NULL, NULL);
	self = (DrtdbQuery*) g_object_new (object_type, NULL);
	_tmp0_ = connection;
	drtdb_query_set_connection (self, _tmp0_);
	_tmp1_ = statement;
	statement = NULL;
	_sqlite3_finalize0 (self->priv->statement);
	self->priv->statement = _tmp1_;
	_tmp2_ = self->priv->statement;
	_tmp3_ = sqlite3_bind_parameter_count (_tmp2_);
	self->n_parameters = _tmp3_;
	_sqlite3_finalize0 (statement);
	return self;
}


DrtdbQuery* drtdb_query_new (DrtdbConnection* connection, sqlite3_stmt* statement) {
	return drtdb_query_construct (DRTDB_TYPE_QUERY, connection, statement);
}


/**
 * Execute SQL query
 * 
 * @param cancellable    Cancellable object
 * @return the result of the query
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbResult* drtdb_query_exec (DrtdbQuery* self, GCancellable* cancellable, GError** error) {
	DrtdbResult* result = NULL;
	DrtdbResult* _result_ = NULL;
	DrtdbResult* _tmp0_ = NULL;
	DrtdbResult* _tmp1_ = NULL;
	GCancellable* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = drtdb_query_get_result (self, &_inner_error_);
	_result_ = _tmp0_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp1_ = _result_;
	_tmp2_ = cancellable;
	drtdb_result_next (_tmp1_, _tmp2_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (_result_);
		return NULL;
	}
	result = _result_;
	return result;
}


/**
 * Executes a select SQL query
 * 
 * Typical usage:
 * 
 * {{{
 * Result result = query.select();
 * while (result.next())
 * {
 *        // process data
 * }
 * }}}
 * 
 * @param cancellable    Cancellable object
 * @return the result of the query
 * @throws GLib.IOError when the operation is cancelled
 * @throws DatabaseError when operation fails
 */
DrtdbResult* drtdb_query_select (DrtdbQuery* self, GCancellable* cancellable, GError** error) {
	DrtdbResult* result = NULL;
	DrtdbResult* _tmp0_ = NULL;
	DrtdbResult* _tmp1_ = NULL;
	DrtdbResult* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = drtdb_query_get_result (self, &_inner_error_);
	_tmp0_ = _tmp1_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	}
	_tmp2_ = _tmp0_;
	_tmp0_ = NULL;
	result = _tmp2_;
	_g_object_unref0 (_tmp0_);
	return result;
}


/**
 * Get result of the query
 * 
 * The query is not executed until {@link Result.next} is called.
 * It is more convenient to call {@link exec} or {@link select} instead.
 * 
 * @return result wrapper
 * @throws DatabaseError if the query has already been executed
 */
DrtdbResult* drtdb_query_get_result (DrtdbQuery* self, GError** error) {
	DrtdbResult* result = NULL;
	DrtdbResult* _result_ = NULL;
	DrtdbConnection* _tmp0_ = NULL;
	sqlite3_stmt* _tmp1_ = NULL;
	DrtdbResult* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp0_ = self->priv->_connection;
	_tmp1_ = self->priv->statement;
	self->priv->statement = NULL;
	_tmp2_ = drtdb_result_new (_tmp0_, _tmp1_);
	_result_ = _tmp2_;
	_sqlite3_finalize0 (self->priv->statement);
	self->priv->statement = NULL;
	result = _result_;
	return result;
}


/**
 * Bind values to query
 * 
 * @param index     the index of the first value placeholder in the SQL query
 * @param values    the values to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when provided data type is not supported or operation fails
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


DrtdbQuery* drtdb_query_bind_values (DrtdbQuery* self, gint index, GSList* values, GError** error) {
	DrtdbQuery* result = NULL;
	guint len = 0U;
	GSList* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	DrtdbQuery* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = values;
	_tmp1_ = g_slist_length (_tmp0_);
	len = _tmp1_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_ = 0;
				guint _tmp5_ = 0U;
				gint _tmp6_ = 0;
				gint _tmp7_ = 0;
				GSList* _tmp8_ = NULL;
				gconstpointer _tmp9_ = NULL;
				DrtdbQuery* _tmp10_ = NULL;
				DrtdbQuery* _tmp11_ = NULL;
				GSList* _tmp12_ = NULL;
				GSList* _tmp13_ = NULL;
				if (!_tmp2_) {
					gint _tmp3_ = 0;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = i;
				_tmp5_ = len;
				if (!(((guint) _tmp4_) < _tmp5_)) {
					break;
				}
				_tmp6_ = index;
				_tmp7_ = i;
				_tmp8_ = values;
				_tmp9_ = _tmp8_->data;
				_tmp10_ = drtdb_query_bind (self, _tmp6_ + _tmp7_, (GValue*) _tmp9_, &_inner_error_);
				_tmp11_ = _tmp10_;
				_g_object_unref0 (_tmp11_);
				if (G_UNLIKELY (_inner_error_ != NULL)) {
					if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
						g_propagate_error (error, _inner_error_);
						return NULL;
					} else {
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
				}
				_tmp12_ = values;
				_tmp13_ = _tmp12_->next;
				values = _tmp13_;
			}
		}
	}
	_tmp14_ = _g_object_ref0 (self);
	result = _tmp14_;
	return result;
}


/**
 * Bind value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when provided data type is not supported or operation fails
 */
DrtdbQuery* drtdb_query_bind (DrtdbQuery* self, gint index, GValue* value, GError** error) {
	DrtdbQuery* result = NULL;
	GValue* _tmp0_ = NULL;
	GType type = 0UL;
	GValue* _tmp5_ = NULL;
	GType _tmp6_ = 0UL;
	GType _tmp7_ = 0UL;
	GType _tmp14_ = 0UL;
	GType _tmp21_ = 0UL;
	GType _tmp28_ = 0UL;
	GType _tmp35_ = 0UL;
	GType _tmp42_ = 0UL;
	GType _tmp49_ = 0UL;
	GType _tmp56_ = 0UL;
	GType _tmp63_ = 0UL;
	GType _tmp73_ = 0UL;
	const gchar* _tmp74_ = NULL;
	GError* _tmp75_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = value;
	if (_tmp0_ == NULL) {
		DrtdbQuery* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		DrtdbQuery* _tmp3_ = NULL;
		DrtdbQuery* _tmp4_ = NULL;
		_tmp2_ = index;
		_tmp3_ = drtdb_query_bind_null (self, _tmp2_, &_inner_error_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		result = _tmp4_;
		_g_object_unref0 (_tmp1_);
		return result;
	}
	_tmp5_ = value;
	_tmp6_ = G_VALUE_TYPE (_tmp5_);
	type = _tmp6_;
	_tmp7_ = type;
	if (_tmp7_ == G_TYPE_BOOLEAN) {
		DrtdbQuery* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		GValue* _tmp10_ = NULL;
		gboolean _tmp11_ = FALSE;
		DrtdbQuery* _tmp12_ = NULL;
		DrtdbQuery* _tmp13_ = NULL;
		_tmp9_ = index;
		_tmp10_ = value;
		_tmp11_ = g_value_get_boolean (_tmp10_);
		_tmp12_ = drtdb_query_bind_bool (self, _tmp9_, _tmp11_, &_inner_error_);
		_tmp8_ = _tmp12_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp13_ = _tmp8_;
		_tmp8_ = NULL;
		result = _tmp13_;
		_g_object_unref0 (_tmp8_);
		return result;
	}
	_tmp14_ = type;
	if (_tmp14_ == G_TYPE_INT) {
		DrtdbQuery* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		GValue* _tmp17_ = NULL;
		gint _tmp18_ = 0;
		DrtdbQuery* _tmp19_ = NULL;
		DrtdbQuery* _tmp20_ = NULL;
		_tmp16_ = index;
		_tmp17_ = value;
		_tmp18_ = g_value_get_int (_tmp17_);
		_tmp19_ = drtdb_query_bind_int (self, _tmp16_, _tmp18_, &_inner_error_);
		_tmp15_ = _tmp19_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp20_ = _tmp15_;
		_tmp15_ = NULL;
		result = _tmp20_;
		_g_object_unref0 (_tmp15_);
		return result;
	}
	_tmp21_ = type;
	if (_tmp21_ == G_TYPE_INT64) {
		DrtdbQuery* _tmp22_ = NULL;
		gint _tmp23_ = 0;
		GValue* _tmp24_ = NULL;
		gint64 _tmp25_ = 0LL;
		DrtdbQuery* _tmp26_ = NULL;
		DrtdbQuery* _tmp27_ = NULL;
		_tmp23_ = index;
		_tmp24_ = value;
		_tmp25_ = g_value_get_int64 (_tmp24_);
		_tmp26_ = drtdb_query_bind_int64 (self, _tmp23_, _tmp25_, &_inner_error_);
		_tmp22_ = _tmp26_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp27_ = _tmp22_;
		_tmp22_ = NULL;
		result = _tmp27_;
		_g_object_unref0 (_tmp22_);
		return result;
	}
	_tmp28_ = type;
	if (_tmp28_ == G_TYPE_STRING) {
		DrtdbQuery* _tmp29_ = NULL;
		gint _tmp30_ = 0;
		GValue* _tmp31_ = NULL;
		const gchar* _tmp32_ = NULL;
		DrtdbQuery* _tmp33_ = NULL;
		DrtdbQuery* _tmp34_ = NULL;
		_tmp30_ = index;
		_tmp31_ = value;
		_tmp32_ = g_value_get_string (_tmp31_);
		_tmp33_ = drtdb_query_bind_string (self, _tmp30_, _tmp32_, &_inner_error_);
		_tmp29_ = _tmp33_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp34_ = _tmp29_;
		_tmp29_ = NULL;
		result = _tmp34_;
		_g_object_unref0 (_tmp29_);
		return result;
	}
	_tmp35_ = type;
	if (_tmp35_ == G_TYPE_DOUBLE) {
		DrtdbQuery* _tmp36_ = NULL;
		gint _tmp37_ = 0;
		GValue* _tmp38_ = NULL;
		gdouble _tmp39_ = 0.0;
		DrtdbQuery* _tmp40_ = NULL;
		DrtdbQuery* _tmp41_ = NULL;
		_tmp37_ = index;
		_tmp38_ = value;
		_tmp39_ = g_value_get_double (_tmp38_);
		_tmp40_ = drtdb_query_bind_double (self, _tmp37_, _tmp39_, &_inner_error_);
		_tmp36_ = _tmp40_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp41_ = _tmp36_;
		_tmp36_ = NULL;
		result = _tmp41_;
		_g_object_unref0 (_tmp36_);
		return result;
	}
	_tmp42_ = type;
	if (_tmp42_ == G_TYPE_FLOAT) {
		DrtdbQuery* _tmp43_ = NULL;
		gint _tmp44_ = 0;
		GValue* _tmp45_ = NULL;
		gfloat _tmp46_ = 0.0F;
		DrtdbQuery* _tmp47_ = NULL;
		DrtdbQuery* _tmp48_ = NULL;
		_tmp44_ = index;
		_tmp45_ = value;
		_tmp46_ = g_value_get_float (_tmp45_);
		_tmp47_ = drtdb_query_bind_double (self, _tmp44_, (gdouble) _tmp46_, &_inner_error_);
		_tmp43_ = _tmp47_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp48_ = _tmp43_;
		_tmp43_ = NULL;
		result = _tmp48_;
		_g_object_unref0 (_tmp43_);
		return result;
	}
	_tmp49_ = type;
	if (_tmp49_ == G_TYPE_BYTES) {
		DrtdbQuery* _tmp50_ = NULL;
		gint _tmp51_ = 0;
		GValue* _tmp52_ = NULL;
		void* _tmp53_ = NULL;
		DrtdbQuery* _tmp54_ = NULL;
		DrtdbQuery* _tmp55_ = NULL;
		_tmp51_ = index;
		_tmp52_ = value;
		_tmp53_ = g_value_get_boxed (_tmp52_);
		_tmp54_ = drtdb_query_bind_bytes (self, _tmp51_, (GBytes*) _tmp53_, &_inner_error_);
		_tmp50_ = _tmp54_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp55_ = _tmp50_;
		_tmp50_ = NULL;
		result = _tmp55_;
		_g_object_unref0 (_tmp50_);
		return result;
	}
	_tmp56_ = type;
	if (_tmp56_ == G_TYPE_BYTE_ARRAY) {
		DrtdbQuery* _tmp57_ = NULL;
		gint _tmp58_ = 0;
		GValue* _tmp59_ = NULL;
		void* _tmp60_ = NULL;
		DrtdbQuery* _tmp61_ = NULL;
		DrtdbQuery* _tmp62_ = NULL;
		_tmp58_ = index;
		_tmp59_ = value;
		_tmp60_ = g_value_get_boxed (_tmp59_);
		_tmp61_ = drtdb_query_bind_byte_array (self, _tmp58_, (GByteArray*) _tmp60_, &_inner_error_);
		_tmp57_ = _tmp61_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp62_ = _tmp57_;
		_tmp57_ = NULL;
		result = _tmp62_;
		_g_object_unref0 (_tmp57_);
		return result;
	}
	_tmp63_ = type;
	if (_tmp63_ == G_TYPE_POINTER) {
		GValue* _tmp64_ = NULL;
		void* _tmp65_ = NULL;
		GType _tmp70_ = 0UL;
		const gchar* _tmp71_ = NULL;
		GError* _tmp72_ = NULL;
		_tmp64_ = value;
		_tmp65_ = g_value_get_pointer (_tmp64_);
		if (_tmp65_ == NULL) {
			DrtdbQuery* _tmp66_ = NULL;
			gint _tmp67_ = 0;
			DrtdbQuery* _tmp68_ = NULL;
			DrtdbQuery* _tmp69_ = NULL;
			_tmp67_ = index;
			_tmp68_ = drtdb_query_bind_null (self, _tmp67_, &_inner_error_);
			_tmp66_ = _tmp68_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
					g_propagate_error (error, _inner_error_);
					return NULL;
				} else {
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
			}
			_tmp69_ = _tmp66_;
			_tmp66_ = NULL;
			result = _tmp69_;
			_g_object_unref0 (_tmp66_);
			return result;
		}
		_tmp70_ = type;
		_tmp71_ = g_type_name (_tmp70_);
		_tmp72_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is supported only with a null pointer.", _tmp71_);
		_inner_error_ = _tmp72_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp73_ = type;
	_tmp74_ = g_type_name (_tmp73_);
	_tmp75_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_DATA_TYPE, "Data type %s is not supported.", _tmp74_);
	_inner_error_ = _tmp75_;
	if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
		g_propagate_error (error, _inner_error_);
		return NULL;
	} else {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


/**
 * Bind null value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_null (DrtdbQuery* self, gint index, GError** error) {
	DrtdbQuery* result = NULL;
	gint _tmp0_ = 0;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	DrtdbQuery* _tmp4_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = index;
	drtdb_query_check_index (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = self->priv->statement;
	_tmp2_ = index;
	_tmp3_ = sqlite3_bind_null (_tmp1_, _tmp2_);
	drtdb_query_throw_on_error (self, _tmp3_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = _g_object_ref0 (self);
	result = _tmp4_;
	return result;
}


/**
 * Bind boolean value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_bool (DrtdbQuery* self, gint index, gboolean value, GError** error) {
	DrtdbQuery* result = NULL;
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	DrtdbQuery* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	DrtdbQuery* _tmp4_ = NULL;
	DrtdbQuery* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = value;
	if (_tmp1_) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = 0;
	}
	_tmp3_ = index;
	_tmp4_ = drtdb_query_bind_int (self, _tmp3_, _tmp0_, &_inner_error_);
	_tmp2_ = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = _tmp2_;
	_tmp2_ = NULL;
	result = _tmp5_;
	_g_object_unref0 (_tmp2_);
	return result;
}


/**
 * Bind integer value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_int (DrtdbQuery* self, gint index, gint value, GError** error) {
	DrtdbQuery* result = NULL;
	gint _tmp0_ = 0;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	DrtdbQuery* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = index;
	drtdb_query_check_index (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = self->priv->statement;
	_tmp2_ = index;
	_tmp3_ = value;
	_tmp4_ = sqlite3_bind_int (_tmp1_, _tmp2_, _tmp3_);
	drtdb_query_throw_on_error (self, _tmp4_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = _g_object_ref0 (self);
	result = _tmp5_;
	return result;
}


/**
 * Bind 64bit integer value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_int64 (DrtdbQuery* self, gint index, gint64 value, GError** error) {
	DrtdbQuery* result = NULL;
	gint _tmp0_ = 0;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint64 _tmp3_ = 0LL;
	gint _tmp4_ = 0;
	DrtdbQuery* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = index;
	drtdb_query_check_index (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = self->priv->statement;
	_tmp2_ = index;
	_tmp3_ = value;
	_tmp4_ = sqlite3_bind_int64 (_tmp1_, _tmp2_, _tmp3_);
	drtdb_query_throw_on_error (self, _tmp4_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = _g_object_ref0 (self);
	result = _tmp5_;
	return result;
}


/**
 * Bind string value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_string (DrtdbQuery* self, gint index, const gchar* value, GError** error) {
	DrtdbQuery* result = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp5_ = 0;
	sqlite3_stmt* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	GDestroyNotify _tmp10_ = NULL;
	gint _tmp11_ = 0;
	DrtdbQuery* _tmp12_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = value;
	if (_tmp0_ == NULL) {
		DrtdbQuery* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		DrtdbQuery* _tmp3_ = NULL;
		DrtdbQuery* _tmp4_ = NULL;
		_tmp2_ = index;
		_tmp3_ = drtdb_query_bind_null (self, _tmp2_, &_inner_error_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		result = _tmp4_;
		_g_object_unref0 (_tmp1_);
		return result;
	}
	_tmp5_ = index;
	drtdb_query_check_index (self, _tmp5_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = self->priv->statement;
	_tmp7_ = index;
	_tmp8_ = value;
	_tmp9_ = g_strdup (_tmp8_);
	_tmp10_ = g_free;
	_tmp11_ = sqlite3_bind_text (_tmp6_, _tmp7_, _tmp9_, -1, _tmp10_);
	drtdb_query_throw_on_error (self, _tmp11_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp12_ = _g_object_ref0 (self);
	result = _tmp12_;
	return result;
}


/**
 * Bind double value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_double (DrtdbQuery* self, gint index, gdouble value, GError** error) {
	DrtdbQuery* result = NULL;
	gint _tmp0_ = 0;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	DrtdbQuery* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = index;
	drtdb_query_check_index (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = self->priv->statement;
	_tmp2_ = index;
	_tmp3_ = value;
	_tmp4_ = sqlite3_bind_double (_tmp1_, _tmp2_, _tmp3_);
	drtdb_query_throw_on_error (self, _tmp4_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp5_ = _g_object_ref0 (self);
	result = _tmp5_;
	return result;
}


/**
 * Bind binary data value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_blob (DrtdbQuery* self, gint index, guint8* value, int value_length1, GError** error) {
	DrtdbQuery* result = NULL;
	gint _tmp0_ = 0;
	sqlite3_stmt* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	guint8* _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	guint8* _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	gint _tmp5_ = 0;
	DrtdbQuery* _tmp6_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = index;
	drtdb_query_check_index (self, _tmp0_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp1_ = self->priv->statement;
	_tmp2_ = index;
	_tmp3_ = value;
	_tmp3__length1 = value_length1;
	_tmp4_ = value;
	_tmp4__length1 = value_length1;
	_tmp5_ = sqlite3_bind_blob (_tmp1_, _tmp2_, _tmp3_, _tmp4__length1, (GDestroyNotify) SQLITE_TRANSIENT);
	drtdb_query_throw_on_error (self, _tmp5_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = _g_object_ref0 (self);
	result = _tmp6_;
	return result;
}


/**
 * Bind {@link GLib.Bytes} value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_bytes (DrtdbQuery* self, gint index, GBytes* value, GError** error) {
	DrtdbQuery* result = NULL;
	GBytes* _tmp0_ = NULL;
	gint _tmp5_ = 0;
	sqlite3_stmt* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	GBytes* _tmp8_ = NULL;
	gsize _tmp9_;
	guint8* _tmp10_ = NULL;
	GBytes* _tmp11_ = NULL;
	gsize _tmp12_ = 0UL;
	gint _tmp13_ = 0;
	DrtdbQuery* _tmp14_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = value;
	if (_tmp0_ == NULL) {
		DrtdbQuery* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		DrtdbQuery* _tmp3_ = NULL;
		DrtdbQuery* _tmp4_ = NULL;
		_tmp2_ = index;
		_tmp3_ = drtdb_query_bind_null (self, _tmp2_, &_inner_error_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		result = _tmp4_;
		_g_object_unref0 (_tmp1_);
		return result;
	}
	_tmp5_ = index;
	drtdb_query_check_index (self, _tmp5_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = self->priv->statement;
	_tmp7_ = index;
	_tmp8_ = value;
	_tmp10_ = g_bytes_get_data (_tmp8_, &_tmp9_);
	_tmp11_ = value;
	_tmp12_ = g_bytes_get_size (_tmp11_);
	_tmp13_ = sqlite3_bind_blob (_tmp6_, _tmp7_, _tmp10_, (gint) _tmp12_, NULL);
	drtdb_query_throw_on_error (self, _tmp13_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp14_ = _g_object_ref0 (self);
	result = _tmp14_;
	return result;
}


/**
 * Bind {@link GLib.ByteArray} value to query
 * 
 * @param index    the index of the value placeholder in the SQL query
 * @param value    the value to bind
 * @return `this` query object for easier chaining
 * @throws DatabaseError when operation fails
 */
DrtdbQuery* drtdb_query_bind_byte_array (DrtdbQuery* self, gint index, GByteArray* value, GError** error) {
	DrtdbQuery* result = NULL;
	GByteArray* _tmp0_ = NULL;
	gint _tmp5_ = 0;
	sqlite3_stmt* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	GByteArray* _tmp8_ = NULL;
	guint8* _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	GByteArray* _tmp10_ = NULL;
	guint _tmp11_ = 0U;
	gint _tmp12_ = 0;
	DrtdbQuery* _tmp13_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = value;
	if (_tmp0_ == NULL) {
		DrtdbQuery* _tmp1_ = NULL;
		gint _tmp2_ = 0;
		DrtdbQuery* _tmp3_ = NULL;
		DrtdbQuery* _tmp4_ = NULL;
		_tmp2_ = index;
		_tmp3_ = drtdb_query_bind_null (self, _tmp2_, &_inner_error_);
		_tmp1_ = _tmp3_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
				g_propagate_error (error, _inner_error_);
				return NULL;
			} else {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		result = _tmp4_;
		_g_object_unref0 (_tmp1_);
		return result;
	}
	_tmp5_ = index;
	drtdb_query_check_index (self, _tmp5_, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	drtdb_query_check_not_executed (self, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp6_ = self->priv->statement;
	_tmp7_ = index;
	_tmp8_ = value;
	_tmp9_ = _tmp8_->data;
	_tmp9__length1 = (gint) _tmp8_->len;
	_tmp10_ = value;
	_tmp11_ = _tmp10_->len;
	_tmp12_ = sqlite3_bind_blob (_tmp6_, _tmp7_, _tmp9_, (gint) _tmp11_, NULL);
	drtdb_query_throw_on_error (self, _tmp12_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp13_ = _g_object_ref0 (self);
	result = _tmp13_;
	return result;
}


/**
 * Throw error if the query has already been executed.
 */
void drtdb_query_check_not_executed (DrtdbQuery* self, GError** error) {
	sqlite3_stmt* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->statement;
	if (_tmp0_ == NULL) {
		sqlite3_stmt* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		GError* _tmp3_ = NULL;
		_tmp1_ = self->priv->statement;
		_tmp2_ = sqlite3_sql (_tmp1_);
		_tmp3_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_MISUSE, "Query has been already executed. |%s|", _tmp2_);
		_inner_error_ = _tmp3_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


/**
 * Throw error if the index is out of bounds.
 */
gint drtdb_query_check_index (DrtdbQuery* self, gint index, GError** error) {
	gint result = 0;
	gint _tmp0_ = 0;
	gboolean _tmp6_ = FALSE;
	gint _tmp7_ = 0;
	gint _tmp17_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->n_parameters;
	if (_tmp0_ == 0) {
		sqlite3_stmt* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
		GError* _tmp3_ = NULL;
		_tmp1_ = self->priv->statement;
		_tmp2_ = sqlite3_sql (_tmp1_);
		_tmp3_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_RANGE, "Query doesn't have parameters. |%s|", _tmp2_);
		_inner_error_ = _tmp3_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			gint _tmp4_ = 0;
			g_propagate_error (error, _inner_error_);
			return _tmp4_;
		} else {
			gint _tmp5_ = 0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp5_;
		}
	}
	_tmp7_ = index;
	if (_tmp7_ <= 0) {
		_tmp6_ = TRUE;
	} else {
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		_tmp8_ = index;
		_tmp9_ = self->n_parameters;
		_tmp6_ = _tmp8_ > _tmp9_;
	}
	if (_tmp6_) {
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		sqlite3_stmt* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		GError* _tmp14_ = NULL;
		_tmp10_ = index;
		_tmp11_ = self->n_parameters;
		_tmp12_ = self->priv->statement;
		_tmp13_ = sqlite3_sql (_tmp12_);
		_tmp14_ = g_error_new (DRTDB_DATABASE_ERROR, DRTDB_DATABASE_ERROR_RANGE, "Index %d is not in range 1..%d. |%s|", _tmp10_, _tmp11_, _tmp13_);
		_inner_error_ = _tmp14_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			gint _tmp15_ = 0;
			g_propagate_error (error, _inner_error_);
			return _tmp15_;
		} else {
			gint _tmp16_ = 0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp16_;
		}
	}
	_tmp17_ = index;
	result = _tmp17_;
	return result;
}


/**
 * Throw error if statement fails.
 */
gint drtdb_query_throw_on_error (DrtdbQuery* self, gint _result_, const gchar* sql, GError** error) {
	gint result = 0;
	gint _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gint _tmp9_ = 0;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = _result_;
	_tmp1_ = drtdb_is_sql_error (_tmp0_);
	if (_tmp1_) {
		gint _tmp2_ = 0;
		DrtdbConnection* _tmp3_ = NULL;
		const gchar* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		GError* _tmp6_ = NULL;
		_tmp2_ = _result_;
		_tmp3_ = self->priv->_connection;
		_tmp4_ = drtdb_queryable_get_last_error_message ((DrtdbQueryable*) _tmp3_);
		_tmp5_ = sql;
		_tmp6_ = drtdb_convert_sqlite_error (_tmp2_, _tmp4_, _tmp5_, NULL);
		_inner_error_ = _tmp6_;
		if (_inner_error_->domain == DRTDB_DATABASE_ERROR) {
			gint _tmp7_ = 0;
			g_propagate_error (error, _inner_error_);
			return _tmp7_;
		} else {
			gint _tmp8_ = 0;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp8_;
		}
	}
	_tmp9_ = _result_;
	result = _tmp9_;
	return result;
}


DrtdbConnection* drtdb_query_get_connection (DrtdbQuery* self) {
	DrtdbConnection* result;
	DrtdbConnection* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_connection;
	result = _tmp0_;
	return result;
}


static void drtdb_query_set_connection (DrtdbQuery* self, DrtdbConnection* value) {
	DrtdbConnection* _tmp0_ = NULL;
	DrtdbConnection* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_connection);
	self->priv->_connection = _tmp1_;
	g_object_notify ((GObject *) self, "connection");
}


static void drtdb_query_class_init (DrtdbQueryClass * klass) {
	drtdb_query_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtdbQueryPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_drtdb_query_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drtdb_query_set_property;
	G_OBJECT_CLASS (klass)->finalize = drtdb_query_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRTDB_QUERY_CONNECTION, g_param_spec_object ("connection", "connection", "connection", DRTDB_TYPE_CONNECTION, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void drtdb_query_instance_init (DrtdbQuery * self) {
	self->priv = DRTDB_QUERY_GET_PRIVATE (self);
	self->priv->statement = NULL;
	self->n_parameters = 0;
}


static void drtdb_query_finalize (GObject* obj) {
	DrtdbQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRTDB_TYPE_QUERY, DrtdbQuery);
	_g_object_unref0 (self->priv->_connection);
	_sqlite3_finalize0 (self->priv->statement);
	G_OBJECT_CLASS (drtdb_query_parent_class)->finalize (obj);
}


/**
 * Database query object
 */
GType drtdb_query_get_type (void) {
	static volatile gsize drtdb_query_type_id__volatile = 0;
	if (g_once_init_enter (&drtdb_query_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtdbQueryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drtdb_query_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtdbQuery), 0, (GInstanceInitFunc) drtdb_query_instance_init, NULL };
		GType drtdb_query_type_id;
		drtdb_query_type_id = g_type_register_static (G_TYPE_OBJECT, "DrtdbQuery", &g_define_type_info, 0);
		g_once_init_leave (&drtdb_query_type_id__volatile, drtdb_query_type_id);
	}
	return drtdb_query_type_id__volatile;
}


static void _vala_drtdb_query_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtdbQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRTDB_TYPE_QUERY, DrtdbQuery);
	switch (property_id) {
		case DRTDB_QUERY_CONNECTION:
		g_value_set_object (value, drtdb_query_get_connection (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drtdb_query_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtdbQuery * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRTDB_TYPE_QUERY, DrtdbQuery);
	switch (property_id) {
		case DRTDB_QUERY_CONNECTION:
		drtdb_query_set_connection (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



