/* RichTextView.c generated by valac 0.34.9, the Vala compiler
 * generated from RichTextView.vala, do not modify */

/*
 * Copyright 2012-2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo.h>


#define DRT_TYPE_RICH_TEXT_VIEW (drt_rich_text_view_get_type ())
#define DRT_RICH_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RICH_TEXT_VIEW, DrtRichTextView))
#define DRT_RICH_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RICH_TEXT_VIEW, DrtRichTextViewClass))
#define DRT_IS_RICH_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RICH_TEXT_VIEW))
#define DRT_IS_RICH_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RICH_TEXT_VIEW))
#define DRT_RICH_TEXT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RICH_TEXT_VIEW, DrtRichTextViewClass))

typedef struct _DrtRichTextView DrtRichTextView;
typedef struct _DrtRichTextViewClass DrtRichTextViewClass;
typedef struct _DrtRichTextViewPrivate DrtRichTextViewPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define DRT_TYPE_RICH_TEXT_BUFFER (drt_rich_text_buffer_get_type ())
#define DRT_RICH_TEXT_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBuffer))
#define DRT_RICH_TEXT_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBufferClass))
#define DRT_IS_RICH_TEXT_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RICH_TEXT_BUFFER))
#define DRT_IS_RICH_TEXT_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RICH_TEXT_BUFFER))
#define DRT_RICH_TEXT_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RICH_TEXT_BUFFER, DrtRichTextBufferClass))

typedef struct _DrtRichTextBuffer DrtRichTextBuffer;
typedef struct _DrtRichTextBufferClass DrtRichTextBufferClass;
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
#define _g_param_spec_unref0(var) ((var == NULL) ? NULL : (var = (g_param_spec_unref (var), NULL)))

#define DRT_TYPE_RICH_TEXT_LINK (drt_rich_text_link_get_type ())
#define DRT_RICH_TEXT_LINK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLink))
#define DRT_RICH_TEXT_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLinkClass))
#define DRT_IS_RICH_TEXT_LINK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_RICH_TEXT_LINK))
#define DRT_IS_RICH_TEXT_LINK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_RICH_TEXT_LINK))
#define DRT_RICH_TEXT_LINK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_RICH_TEXT_LINK, DrtRichTextLinkClass))

typedef struct _DrtRichTextLink DrtRichTextLink;
typedef struct _DrtRichTextLinkClass DrtRichTextLinkClass;
#define _g_slist_free0(var) ((var == NULL) ? NULL : (var = (g_slist_free (var), NULL)))

typedef void (*DrtUriOpener) (const gchar* uri, void* user_data);
struct _DrtRichTextView {
	GtkTextView parent_instance;
	DrtRichTextViewPrivate * priv;
};

struct _DrtRichTextViewClass {
	GtkTextViewClass parent_class;
	void (*link_clicked) (DrtRichTextView* self, const gchar* uri);
	void (*image_clicked) (DrtRichTextView* self, const gchar* path);
};

struct _DrtRichTextViewPrivate {
	DrtUriOpener _link_opener;
	gpointer _link_opener_target;
	GDestroyNotify _link_opener_target_destroy_notify;
	DrtUriOpener _image_opener;
	gpointer _image_opener_target;
	GDestroyNotify _image_opener_target_destroy_notify;
	GdkCursor* cursor;
};


static gpointer drt_rich_text_view_parent_class = NULL;

GType drt_rich_text_view_get_type (void) G_GNUC_CONST;
#define DRT_RICH_TEXT_VIEW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_RICH_TEXT_VIEW, DrtRichTextViewPrivate))
enum  {
	DRT_RICH_TEXT_VIEW_DUMMY_PROPERTY
};
void drt_rich_text_view_default_opener (const gchar* uri);
GType drt_rich_text_buffer_get_type (void) G_GNUC_CONST;
DrtRichTextView* drt_rich_text_view_new (DrtRichTextBuffer* buffer);
DrtRichTextView* drt_rich_text_view_construct (GType object_type, DrtRichTextBuffer* buffer);
static void _drt_rich_text_view_default_opener_drt_uri_opener (const gchar* uri, gpointer self);
void drt_rich_text_view_set_link_opener (DrtRichTextView* self, DrtUriOpener value, gpointer value_target, GDestroyNotify value_target_destroy_notify);
void drt_rich_text_view_set_image_opener (DrtRichTextView* self, DrtUriOpener value, gpointer value_target, GDestroyNotify value_target_destroy_notify);
DrtRichTextBuffer* drt_rich_text_buffer_new (void);
DrtRichTextBuffer* drt_rich_text_buffer_construct (GType object_type);
static void drt_rich_text_view_real_realize (GtkWidget* base);
static void drt_rich_text_view_set_link_color (DrtRichTextView* self);
static void drt_rich_text_view_real_style_updated (GtkWidget* base);
static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self);
void drt_rich_text_buffer_set_link_color (DrtRichTextBuffer* self, GdkRGBA* value);
static gboolean drt_rich_text_view_real_button_release_event (GtkWidget* base, GdkEventButton* event);
GType drt_rich_text_link_get_type (void) G_GNUC_CONST;
gboolean drt_rich_text_view_get_link_at_pos (DrtRichTextView* self, gint x, gint y, DrtRichTextLink** link);
const gchar* drt_rich_text_link_get_uri (DrtRichTextLink* self);
GdkPixbuf* drt_rich_text_view_get_pixbuf_at_pos (DrtRichTextView* self, gint x, gint y);
#define DRT_RICH_TEXT_BUFFER_IMAGE_PATH "path"
gboolean drt_rich_text_view_is_in_iter_area (DrtRichTextView* self, GtkTextIter* iter, gint x, gint y);
static gboolean drt_rich_text_view_real_motion_notify_event (GtkWidget* base, GdkEventMotion* event);
static void drt_rich_text_view_update_cursor (DrtRichTextView* self, gint x, gint y);
DrtUriOpener drt_rich_text_view_get_link_opener (DrtRichTextView* self, gpointer* result_target);
DrtUriOpener drt_rich_text_view_get_image_opener (DrtRichTextView* self, gpointer* result_target);
static void drt_rich_text_view_real_link_clicked (DrtRichTextView* self, const gchar* uri);
static void drt_rich_text_view_real_image_clicked (DrtRichTextView* self, const gchar* path);
static void drt_rich_text_view_finalize (GObject* obj);
static void _vala_drt_rich_text_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_rich_text_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


void drt_rich_text_view_default_opener (const gchar* uri) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (uri != NULL);
	{
		const gchar* _tmp0_ = NULL;
		_tmp0_ = uri;
		gtk_show_uri (NULL, _tmp0_, (guint32) GDK_CURRENT_TIME, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch9_g_error;
		}
	}
	goto __finally9;
	__catch9_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp1_ = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp1_ = uri;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_critical ("RichTextView.vala:53: Failed to open URI '%s'. %s", _tmp1_, _tmp3_);
		_g_error_free0 (e);
	}
	__finally9:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
 * Creates new SimpleDocView.
 */
static void _drt_rich_text_view_default_opener_drt_uri_opener (const gchar* uri, gpointer self) {
	drt_rich_text_view_default_opener (uri);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


DrtRichTextView* drt_rich_text_view_construct (GType object_type, DrtRichTextBuffer* buffer) {
	DrtRichTextView * self = NULL;
	DrtRichTextBuffer* _tmp0_ = NULL;
	DrtRichTextBuffer* _tmp1_ = NULL;
	DrtRichTextBuffer* _tmp2_ = NULL;
	self = (DrtRichTextView*) g_object_new (object_type, "editable", FALSE, "wrap-mode", GTK_WRAP_WORD, NULL);
	drt_rich_text_view_set_link_opener (self, _drt_rich_text_view_default_opener_drt_uri_opener, NULL, NULL);
	drt_rich_text_view_set_image_opener (self, _drt_rich_text_view_default_opener_drt_uri_opener, NULL, NULL);
	_tmp1_ = buffer;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	_tmp0_ = _tmp2_;
	if (_tmp0_ == NULL) {
		DrtRichTextBuffer* _tmp3_ = NULL;
		_tmp3_ = drt_rich_text_buffer_new ();
		_g_object_unref0 (_tmp0_);
		_tmp0_ = _tmp3_;
	}
	gtk_text_view_set_buffer ((GtkTextView*) self, (GtkTextBuffer*) _tmp0_);
	_g_object_unref0 (_tmp0_);
	return self;
}


DrtRichTextView* drt_rich_text_view_new (DrtRichTextBuffer* buffer) {
	return drt_rich_text_view_construct (DRT_TYPE_RICH_TEXT_VIEW, buffer);
}


static void drt_rich_text_view_real_realize (GtkWidget* base) {
	DrtRichTextView * self;
	self = (DrtRichTextView*) base;
	GTK_WIDGET_CLASS (drt_rich_text_view_parent_class)->realize ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_text_view_get_type (), GtkTextView));
	drt_rich_text_view_set_link_color (self);
}


static void drt_rich_text_view_real_style_updated (GtkWidget* base) {
	DrtRichTextView * self;
	gboolean _tmp0_ = FALSE;
	self = (DrtRichTextView*) base;
	GTK_WIDGET_CLASS (drt_rich_text_view_parent_class)->style_updated ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_text_view_get_type (), GtkTextView));
	_tmp0_ = gtk_widget_get_realized ((GtkWidget*) self);
	if (_tmp0_) {
		drt_rich_text_view_set_link_color (self);
	}
}


static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self) {
	GdkRGBA* dup;
	dup = g_new0 (GdkRGBA, 1);
	memcpy (dup, self, sizeof (GdkRGBA));
	return dup;
}


static gpointer __gdk_rgba_dup0 (gpointer self) {
	return self ? _gdk_rgba_dup (self) : NULL;
}


static gpointer _g_param_spec_ref0 (gpointer self) {
	return self ? g_param_spec_ref (self) : NULL;
}


static void drt_rich_text_view_set_link_color (DrtRichTextView* self) {
	GdkRGBA* link_color = NULL;
	DrtRichTextBuffer* doc_buffer = NULL;
	GtkTextBuffer* _tmp0_ = NULL;
	GtkTextBuffer* _tmp1_ = NULL;
	DrtRichTextBuffer* _tmp2_ = NULL;
	DrtRichTextBuffer* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	GtkStyleContext* _tmp5_ = NULL;
	GdkRGBA _tmp6_ = {0};
	gboolean _tmp7_ = FALSE;
	GdkRGBA _tmp8_ = {0};
	GdkRGBA* _tmp9_ = NULL;
	GdkRGBA* _tmp31_ = NULL;
	g_return_if_fail (self != NULL);
	link_color = NULL;
	_tmp0_ = gtk_text_view_get_buffer ((GtkTextView*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, DRT_TYPE_RICH_TEXT_BUFFER) ? ((DrtRichTextBuffer*) _tmp1_) : NULL);
	doc_buffer = _tmp2_;
	_tmp3_ = doc_buffer;
	if (_tmp3_ == NULL) {
		_g_object_unref0 (doc_buffer);
		_g_free0 (link_color);
		return;
	}
	_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp7_ = gtk_style_context_lookup_color (_tmp5_, "link-color", &_tmp6_);
	_g_free0 (link_color);
	_tmp8_ = _tmp6_;
	_tmp9_ = __gdk_rgba_dup0 (&_tmp8_);
	link_color = _tmp9_;
	if (!_tmp7_) {
		GtkStyleContext* _tmp10_ = NULL;
		GdkRGBA _tmp11_ = {0};
		gboolean _tmp12_ = FALSE;
		GdkRGBA _tmp13_ = {0};
		GdkRGBA* _tmp14_ = NULL;
		_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp12_ = gtk_style_context_lookup_color (_tmp10_, "link_color", &_tmp11_);
		_g_free0 (link_color);
		_tmp13_ = _tmp11_;
		_tmp14_ = __gdk_rgba_dup0 (&_tmp13_);
		link_color = _tmp14_;
		_tmp4_ = !_tmp12_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GParamSpec* prop = NULL;
		GParamSpec* _tmp15_ = NULL;
		GParamSpec* _tmp16_ = NULL;
		GParamSpec* _tmp17_ = NULL;
		_g_free0 (link_color);
		link_color = NULL;
		_tmp15_ = gtk_widget_class_find_style_property (GTK_WIDGET_CLASS (G_OBJECT_GET_CLASS (self)), "link-color");
		_tmp16_ = _g_param_spec_ref0 (_tmp15_);
		prop = _tmp16_;
		_tmp17_ = prop;
		if (_tmp17_ != NULL) {
			GdkColor* color = NULL;
			gboolean _tmp18_ = FALSE;
			GParamSpec* _tmp19_ = NULL;
			GType _tmp20_ = 0UL;
			gboolean _tmp21_ = FALSE;
			color = NULL;
			gtk_widget_style_get ((GtkWidget*) self, "link-color", &color, NULL);
			_tmp19_ = prop;
			_tmp20_ = _tmp19_->value_type;
			_tmp21_ = g_type_is_a (_tmp20_, gdk_color_get_type ());
			if (!_tmp21_) {
				GdkColor* _tmp22_ = NULL;
				_tmp22_ = color;
				_tmp18_ = _tmp22_ != NULL;
			} else {
				_tmp18_ = FALSE;
			}
			if (_tmp18_) {
				GdkColor* _tmp23_ = NULL;
				guint16 _tmp24_ = 0U;
				GdkColor* _tmp25_ = NULL;
				guint16 _tmp26_ = 0U;
				GdkColor* _tmp27_ = NULL;
				guint16 _tmp28_ = 0U;
				GdkRGBA _tmp29_ = {0};
				GdkRGBA* _tmp30_ = NULL;
				_tmp23_ = color;
				_tmp24_ = (*_tmp23_).red;
				_tmp25_ = color;
				_tmp26_ = (*_tmp25_).green;
				_tmp27_ = color;
				_tmp28_ = (*_tmp27_).blue;
				_tmp29_.red = _tmp24_ / 65535.0;
				_tmp29_.green = _tmp26_ / 65535.0;
				_tmp29_.blue = _tmp28_ / 65535.0;
				_tmp29_.alpha = 1.0;
				_tmp30_ = __gdk_rgba_dup0 (&_tmp29_);
				_g_free0 (link_color);
				link_color = _tmp30_;
			}
		}
		_g_param_spec_unref0 (prop);
	}
	_tmp31_ = link_color;
	if (_tmp31_ != NULL) {
		DrtRichTextBuffer* _tmp32_ = NULL;
		GdkRGBA* _tmp33_ = NULL;
		_tmp32_ = doc_buffer;
		_tmp33_ = link_color;
		drt_rich_text_buffer_set_link_color (_tmp32_, _tmp33_);
	}
	_g_object_unref0 (doc_buffer);
	_g_free0 (link_color);
}


static gboolean drt_rich_text_view_real_button_release_event (GtkWidget* base, GdkEventButton* event) {
	DrtRichTextView * self;
	gboolean result = FALSE;
	gboolean cont = FALSE;
	GdkEventButton* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GdkEventButton* _tmp2_ = NULL;
	guint _tmp3_ = 0U;
	self = (DrtRichTextView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = GTK_WIDGET_CLASS (drt_rich_text_view_parent_class)->button_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_text_view_get_type (), GtkTextView), _tmp0_);
	cont = _tmp1_;
	_tmp2_ = event;
	_tmp3_ = _tmp2_->button;
	if (_tmp3_ == ((guint) 1)) {
		gint x = 0;
		gint y = 0;
		GdkEventButton* _tmp4_ = NULL;
		gdouble _tmp5_ = 0.0;
		GdkEventButton* _tmp6_ = NULL;
		gdouble _tmp7_ = 0.0;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		DrtRichTextLink* link = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		DrtRichTextLink* _tmp12_ = NULL;
		gboolean _tmp13_ = FALSE;
		_tmp4_ = event;
		_tmp5_ = _tmp4_->x;
		_tmp6_ = event;
		_tmp7_ = _tmp6_->y;
		gtk_text_view_window_to_buffer_coords ((GtkTextView*) self, GTK_TEXT_WINDOW_TEXT, (gint) _tmp5_, (gint) _tmp7_, &_tmp8_, &_tmp9_);
		x = _tmp8_;
		y = _tmp9_;
		_tmp10_ = x;
		_tmp11_ = y;
		_tmp13_ = drt_rich_text_view_get_link_at_pos (self, _tmp10_, _tmp11_, &_tmp12_);
		link = _tmp12_;
		if (_tmp13_) {
			DrtRichTextLink* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_ = NULL;
			_tmp14_ = link;
			_tmp15_ = drt_rich_text_link_get_uri (_tmp14_);
			_tmp16_ = _tmp15_;
			g_signal_emit_by_name (self, "link-clicked", _tmp16_);
		} else {
			GdkPixbuf* pixbuf = NULL;
			gint _tmp17_ = 0;
			gint _tmp18_ = 0;
			GdkPixbuf* _tmp19_ = NULL;
			GdkPixbuf* _tmp20_ = NULL;
			_tmp17_ = x;
			_tmp18_ = y;
			_tmp19_ = drt_rich_text_view_get_pixbuf_at_pos (self, _tmp17_, _tmp18_);
			pixbuf = _tmp19_;
			_tmp20_ = pixbuf;
			if (_tmp20_ != NULL) {
				gchar* path = NULL;
				GdkPixbuf* _tmp21_ = NULL;
				gconstpointer _tmp22_ = NULL;
				gchar* _tmp23_ = NULL;
				const gchar* _tmp24_ = NULL;
				_tmp21_ = pixbuf;
				_tmp22_ = g_object_get_data ((GObject*) _tmp21_, DRT_RICH_TEXT_BUFFER_IMAGE_PATH);
				_tmp23_ = g_strdup ((const gchar*) _tmp22_);
				path = _tmp23_;
				_tmp24_ = path;
				if (_tmp24_ != NULL) {
					const gchar* _tmp25_ = NULL;
					_tmp25_ = path;
					g_signal_emit_by_name (self, "image-clicked", _tmp25_);
				}
				_g_free0 (path);
			}
			_g_object_unref0 (pixbuf);
		}
	}
	result = cont;
	return result;
}


/**
 * Get link at given position
 * 
 * @param x       x coordinate
 * @param y       y coordinate
 * @param link    link when found
 * @return true if a link has been found
 */
gboolean drt_rich_text_view_get_link_at_pos (DrtRichTextView* self, gint x, gint y, DrtRichTextLink** link) {
	DrtRichTextLink* _vala_link = NULL;
	gboolean result = FALSE;
	GtkTextIter iter = {0};
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GtkTextIter _tmp2_ = {0};
	GSList* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_vala_link = NULL;
	_tmp0_ = x;
	_tmp1_ = y;
	gtk_text_view_get_iter_at_location ((GtkTextView*) self, &_tmp2_, _tmp0_, _tmp1_);
	iter = _tmp2_;
	_tmp3_ = gtk_text_iter_get_tags (&iter);
	{
		GSList* tag_collection = NULL;
		GSList* tag_it = NULL;
		tag_collection = _tmp3_;
		for (tag_it = tag_collection; tag_it != NULL; tag_it = tag_it->next) {
			GtkTextTag* tag = NULL;
			tag = (GtkTextTag*) tag_it->data;
			{
				DrtRichTextLink* maybe_link = NULL;
				GtkTextTag* _tmp4_ = NULL;
				DrtRichTextLink* _tmp5_ = NULL;
				_tmp4_ = tag;
				maybe_link = G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, DRT_TYPE_RICH_TEXT_LINK) ? ((DrtRichTextLink*) _tmp4_) : NULL;
				_tmp5_ = maybe_link;
				if (_tmp5_ != NULL) {
					DrtRichTextLink* _tmp6_ = NULL;
					_tmp6_ = maybe_link;
					_vala_link = _tmp6_;
					result = TRUE;
					_g_slist_free0 (tag_collection);
					if (link) {
						*link = _vala_link;
					}
					return result;
				}
			}
		}
		_g_slist_free0 (tag_collection);
	}
	result = FALSE;
	if (link) {
		*link = _vala_link;
	}
	return result;
}


/**
 * Check whether position is inside iter area.
 * 
 * @param iter    iter
 * @param x       x coordinate
 * @param y       y coordinate
 * @return true if (x, y) is inside area of iter
 */
gboolean drt_rich_text_view_is_in_iter_area (DrtRichTextView* self, GtkTextIter* iter, gint x, gint y) {
	gboolean result = FALSE;
	GdkRectangle area = {0};
	GtkTextIter _tmp0_ = {0};
	GdkRectangle _tmp1_ = {0};
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gint _tmp5_ = 0;
	GdkRectangle _tmp6_ = {0};
	gint _tmp7_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = *iter;
	gtk_text_view_get_iter_location ((GtkTextView*) self, &_tmp0_, &_tmp1_);
	area = _tmp1_;
	_tmp5_ = x;
	_tmp6_ = area;
	_tmp7_ = _tmp6_.x;
	if (_tmp5_ >= _tmp7_) {
		gint _tmp8_ = 0;
		GdkRectangle _tmp9_ = {0};
		gint _tmp10_ = 0;
		GdkRectangle _tmp11_ = {0};
		gint _tmp12_ = 0;
		_tmp8_ = x;
		_tmp9_ = area;
		_tmp10_ = _tmp9_.x;
		_tmp11_ = area;
		_tmp12_ = _tmp11_.width;
		_tmp4_ = _tmp8_ <= (_tmp10_ + _tmp12_);
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		gint _tmp13_ = 0;
		GdkRectangle _tmp14_ = {0};
		gint _tmp15_ = 0;
		_tmp13_ = y;
		_tmp14_ = area;
		_tmp15_ = _tmp14_.y;
		_tmp3_ = _tmp13_ >= _tmp15_;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gint _tmp16_ = 0;
		GdkRectangle _tmp17_ = {0};
		gint _tmp18_ = 0;
		GdkRectangle _tmp19_ = {0};
		gint _tmp20_ = 0;
		_tmp16_ = y;
		_tmp17_ = area;
		_tmp18_ = _tmp17_.y;
		_tmp19_ = area;
		_tmp20_ = _tmp19_.height;
		_tmp2_ = _tmp16_ <= (_tmp18_ + _tmp20_);
	} else {
		_tmp2_ = FALSE;
	}
	result = _tmp2_;
	return result;
}


/**
 * Get pixbuf at given position.
 * 
 * @param x    coordinate x
 * @param y    coordinate y
 * @return pixbuf if found, null otherwise
 */
GdkPixbuf* drt_rich_text_view_get_pixbuf_at_pos (DrtRichTextView* self, gint x, gint y) {
	GdkPixbuf* result = NULL;
	GtkTextIter iter = {0};
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GtkTextIter _tmp2_ = {0};
	GdkPixbuf* pixbuf = NULL;
	GdkPixbuf* _tmp3_ = NULL;
	GdkPixbuf* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GdkPixbuf* _tmp6_ = NULL;
	GdkPixbuf* _tmp11_ = NULL;
	GdkPixbuf* _tmp12_ = NULL;
	gboolean _tmp13_ = FALSE;
	GdkPixbuf* _tmp14_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = x;
	_tmp1_ = y;
	gtk_text_view_get_iter_at_location ((GtkTextView*) self, &_tmp2_, _tmp0_, _tmp1_);
	iter = _tmp2_;
	_tmp3_ = gtk_text_iter_get_pixbuf (&iter);
	_tmp4_ = _g_object_ref0 (_tmp3_);
	pixbuf = _tmp4_;
	_tmp6_ = pixbuf;
	if (_tmp6_ != NULL) {
		GtkTextIter _tmp7_ = {0};
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gboolean _tmp10_ = FALSE;
		_tmp7_ = iter;
		_tmp8_ = x;
		_tmp9_ = y;
		_tmp10_ = drt_rich_text_view_is_in_iter_area (self, &_tmp7_, _tmp8_, _tmp9_);
		_tmp5_ = _tmp10_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		result = pixbuf;
		return result;
	}
	gtk_text_iter_backward_char (&iter);
	_tmp11_ = gtk_text_iter_get_pixbuf (&iter);
	_tmp12_ = _g_object_ref0 (_tmp11_);
	_g_object_unref0 (pixbuf);
	pixbuf = _tmp12_;
	_tmp14_ = pixbuf;
	if (_tmp14_ != NULL) {
		GtkTextIter _tmp15_ = {0};
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		gboolean _tmp18_ = FALSE;
		_tmp15_ = iter;
		_tmp16_ = x;
		_tmp17_ = y;
		_tmp18_ = drt_rich_text_view_is_in_iter_area (self, &_tmp15_, _tmp16_, _tmp17_);
		_tmp13_ = _tmp18_;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		result = pixbuf;
		return result;
	}
	result = NULL;
	_g_object_unref0 (pixbuf);
	return result;
}


static gboolean drt_rich_text_view_real_motion_notify_event (GtkWidget* base, GdkEventMotion* event) {
	DrtRichTextView * self;
	gboolean result = FALSE;
	gboolean cont = FALSE;
	GdkEventMotion* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gint x = 0;
	gint y = 0;
	GdkEventMotion* _tmp2_ = NULL;
	gdouble _tmp3_ = 0.0;
	GdkEventMotion* _tmp4_ = NULL;
	gdouble _tmp5_ = 0.0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	self = (DrtRichTextView*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	_tmp0_ = event;
	_tmp1_ = GTK_WIDGET_CLASS (drt_rich_text_view_parent_class)->motion_notify_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_text_view_get_type (), GtkTextView), _tmp0_);
	cont = _tmp1_;
	_tmp2_ = event;
	_tmp3_ = _tmp2_->x;
	_tmp4_ = event;
	_tmp5_ = _tmp4_->y;
	gtk_text_view_window_to_buffer_coords ((GtkTextView*) self, GTK_TEXT_WINDOW_TEXT, (gint) _tmp3_, (gint) _tmp5_, &_tmp6_, &_tmp7_);
	x = _tmp6_;
	y = _tmp7_;
	drt_rich_text_view_update_cursor (self, x, y);
	result = cont;
	return result;
}


static void drt_rich_text_view_update_cursor (DrtRichTextView* self, gint x, gint y) {
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_ = NULL;
	GdkDisplay* _tmp1_ = NULL;
	GdkCursor* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp6_ = FALSE;
	GdkCursor* cursor = NULL;
	GdkCursor* _tmp13_ = NULL;
	GdkCursor* _tmp14_ = NULL;
	GdkCursor* _tmp15_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_widget_get_display ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	display = _tmp1_;
	_tmp4_ = x;
	_tmp5_ = y;
	_tmp6_ = drt_rich_text_view_get_link_at_pos (self, _tmp4_, _tmp5_, NULL);
	if (_tmp6_) {
		_tmp3_ = TRUE;
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		GdkPixbuf* _tmp9_ = NULL;
		GdkPixbuf* _tmp10_ = NULL;
		_tmp7_ = x;
		_tmp8_ = y;
		_tmp9_ = drt_rich_text_view_get_pixbuf_at_pos (self, _tmp7_, _tmp8_);
		_tmp10_ = _tmp9_;
		_tmp3_ = _tmp10_ != NULL;
		_g_object_unref0 (_tmp10_);
	}
	if (_tmp3_) {
		GdkDisplay* _tmp11_ = NULL;
		GdkCursor* _tmp12_ = NULL;
		_tmp11_ = display;
		_tmp12_ = gdk_cursor_new_for_display (_tmp11_, GDK_HAND2);
		_g_object_unref0 (_tmp2_);
		_tmp2_ = _tmp12_;
	} else {
		_g_object_unref0 (_tmp2_);
		_tmp2_ = NULL;
	}
	_tmp13_ = _g_object_ref0 (_tmp2_);
	cursor = _tmp13_;
	_tmp14_ = self->priv->cursor;
	_tmp15_ = cursor;
	if (_tmp14_ != _tmp15_) {
		GdkWindow* _tmp16_ = NULL;
		GdkCursor* _tmp17_ = NULL;
		GdkDisplay* _tmp18_ = NULL;
		GdkCursor* _tmp19_ = NULL;
		GdkCursor* _tmp20_ = NULL;
		_tmp16_ = gtk_text_view_get_window ((GtkTextView*) self, GTK_TEXT_WINDOW_TEXT);
		_tmp17_ = cursor;
		gdk_window_set_cursor (_tmp16_, _tmp17_);
		_tmp18_ = display;
		gdk_display_flush (_tmp18_);
		_tmp19_ = cursor;
		_tmp20_ = _g_object_ref0 (_tmp19_);
		_g_object_unref0 (self->priv->cursor);
		self->priv->cursor = _tmp20_;
	}
	_g_object_unref0 (cursor);
	_g_object_unref0 (_tmp2_);
	_g_object_unref0 (display);
}


DrtUriOpener drt_rich_text_view_get_link_opener (DrtRichTextView* self, gpointer* result_target) {
	DrtUriOpener result;
	DrtUriOpener _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	DrtUriOpener _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_link_opener;
	_tmp0__target = self->priv->_link_opener_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


void drt_rich_text_view_set_link_opener (DrtRichTextView* self, DrtUriOpener value, gpointer value_target, GDestroyNotify value_target_destroy_notify) {
	DrtUriOpener _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__target = value_target;
	_tmp0__target_destroy_notify = value_target_destroy_notify;
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
	(self->priv->_link_opener_target_destroy_notify == NULL) ? NULL : (self->priv->_link_opener_target_destroy_notify (self->priv->_link_opener_target), NULL);
	self->priv->_link_opener = NULL;
	self->priv->_link_opener_target = NULL;
	self->priv->_link_opener_target_destroy_notify = NULL;
	self->priv->_link_opener = _tmp0_;
	self->priv->_link_opener_target = _tmp0__target;
	self->priv->_link_opener_target_destroy_notify = _tmp0__target_destroy_notify;
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
}


DrtUriOpener drt_rich_text_view_get_image_opener (DrtRichTextView* self, gpointer* result_target) {
	DrtUriOpener result;
	DrtUriOpener _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	DrtUriOpener _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_image_opener;
	_tmp0__target = self->priv->_image_opener_target;
	_tmp1_ = _tmp0_;
	_tmp1__target = _tmp0__target;
	*result_target = _tmp1__target;
	result = _tmp1_;
	return result;
}


void drt_rich_text_view_set_image_opener (DrtRichTextView* self, DrtUriOpener value, gpointer value_target, GDestroyNotify value_target_destroy_notify) {
	DrtUriOpener _tmp0_ = NULL;
	void* _tmp0__target = NULL;
	GDestroyNotify _tmp0__target_destroy_notify = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp0__target = value_target;
	_tmp0__target_destroy_notify = value_target_destroy_notify;
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
	(self->priv->_image_opener_target_destroy_notify == NULL) ? NULL : (self->priv->_image_opener_target_destroy_notify (self->priv->_image_opener_target), NULL);
	self->priv->_image_opener = NULL;
	self->priv->_image_opener_target = NULL;
	self->priv->_image_opener_target_destroy_notify = NULL;
	self->priv->_image_opener = _tmp0_;
	self->priv->_image_opener_target = _tmp0__target;
	self->priv->_image_opener_target_destroy_notify = _tmp0__target_destroy_notify;
	(value_target_destroy_notify == NULL) ? NULL : (value_target_destroy_notify (value_target), NULL);
	value = NULL;
	value_target = NULL;
	value_target_destroy_notify = NULL;
}


static void drt_rich_text_view_real_link_clicked (DrtRichTextView* self, const gchar* uri) {
	const gchar* _tmp0_ = NULL;
	DrtUriOpener _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	DrtUriOpener _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	g_return_if_fail (uri != NULL);
	_tmp0_ = uri;
	g_debug ("RichTextView.vala:76: Open link: %s", _tmp0_);
	_tmp1_ = drt_rich_text_view_get_link_opener (self, &_tmp1__target);
	_tmp2_ = _tmp1_;
	_tmp2__target = _tmp1__target;
	if (_tmp2_ != NULL) {
		DrtUriOpener _tmp3_ = NULL;
		void* _tmp3__target = NULL;
		DrtUriOpener _tmp4_ = NULL;
		void* _tmp4__target = NULL;
		const gchar* _tmp5_ = NULL;
		_tmp3_ = drt_rich_text_view_get_link_opener (self, &_tmp3__target);
		_tmp4_ = _tmp3_;
		_tmp4__target = _tmp3__target;
		_tmp5_ = uri;
		_tmp4_ (_tmp5_, _tmp4__target);
	}
}


static void drt_rich_text_view_real_image_clicked (DrtRichTextView* self, const gchar* path) {
	const gchar* _tmp0_ = NULL;
	DrtUriOpener _tmp1_ = NULL;
	void* _tmp1__target = NULL;
	DrtUriOpener _tmp2_ = NULL;
	void* _tmp2__target = NULL;
	g_return_if_fail (path != NULL);
	_tmp0_ = path;
	g_debug ("RichTextView.vala:89: Open image: %s", _tmp0_);
	_tmp1_ = drt_rich_text_view_get_image_opener (self, &_tmp1__target);
	_tmp2_ = _tmp1_;
	_tmp2__target = _tmp1__target;
	if (_tmp2_ != NULL) {
		DrtUriOpener _tmp3_ = NULL;
		void* _tmp3__target = NULL;
		DrtUriOpener _tmp4_ = NULL;
		void* _tmp4__target = NULL;
		const gchar* _tmp5_ = NULL;
		_tmp3_ = drt_rich_text_view_get_image_opener (self, &_tmp3__target);
		_tmp4_ = _tmp3_;
		_tmp4__target = _tmp3__target;
		_tmp5_ = path;
		_tmp4_ (_tmp5_, _tmp4__target);
	}
}


static void drt_rich_text_view_class_init (DrtRichTextViewClass * klass) {
	drt_rich_text_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtRichTextViewPrivate));
	((GtkWidgetClass *) klass)->realize = (void (*)(GtkWidget*)) drt_rich_text_view_real_realize;
	((GtkWidgetClass *) klass)->style_updated = (void (*)(GtkWidget*)) drt_rich_text_view_real_style_updated;
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*)(GtkWidget*, GdkEventButton*)) drt_rich_text_view_real_button_release_event;
	((GtkWidgetClass *) klass)->motion_notify_event = (gboolean (*)(GtkWidget*, GdkEventMotion*)) drt_rich_text_view_real_motion_notify_event;
	((DrtRichTextViewClass *) klass)->link_clicked = drt_rich_text_view_real_link_clicked;
	((DrtRichTextViewClass *) klass)->image_clicked = drt_rich_text_view_real_image_clicked;
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_rich_text_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_rich_text_view_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_rich_text_view_finalize;
	/**
	 * Emitted when a link is clicked. The default handler opens the link
	 * via link_opener field.
	 * 
	 * @param uri    target URI of the link
	 */
	g_signal_new ("link_clicked", DRT_TYPE_RICH_TEXT_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DrtRichTextViewClass, link_clicked), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	/**
	 * Emitted when an image is clicked. The default handler opens the image
	 * via image_opener field.
	 * 
	 * @param path    path of the image
	 */
	g_signal_new ("image_clicked", DRT_TYPE_RICH_TEXT_VIEW, G_SIGNAL_RUN_LAST, G_STRUCT_OFFSET (DrtRichTextViewClass, image_clicked), NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}


static void drt_rich_text_view_instance_init (DrtRichTextView * self) {
	self->priv = DRT_RICH_TEXT_VIEW_GET_PRIVATE (self);
	self->priv->cursor = NULL;
}


static void drt_rich_text_view_finalize (GObject* obj) {
	DrtRichTextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_RICH_TEXT_VIEW, DrtRichTextView);
	(self->priv->_link_opener_target_destroy_notify == NULL) ? NULL : (self->priv->_link_opener_target_destroy_notify (self->priv->_link_opener_target), NULL);
	self->priv->_link_opener = NULL;
	self->priv->_link_opener_target = NULL;
	self->priv->_link_opener_target_destroy_notify = NULL;
	(self->priv->_image_opener_target_destroy_notify == NULL) ? NULL : (self->priv->_image_opener_target_destroy_notify (self->priv->_image_opener_target), NULL);
	self->priv->_image_opener = NULL;
	self->priv->_image_opener_target = NULL;
	self->priv->_image_opener_target_destroy_notify = NULL;
	_g_object_unref0 (self->priv->cursor);
	G_OBJECT_CLASS (drt_rich_text_view_parent_class)->finalize (obj);
}


/**
 * Simple Document View is supposed to properly display content of SimpleDocBuffer.
 * 
 * It understands all formating tags of SimpleDocBuffer, sets proper link color and
 * manages link actions (changes cursor and emits link_clicked signal).
 */
GType drt_rich_text_view_get_type (void) {
	static volatile gsize drt_rich_text_view_type_id__volatile = 0;
	if (g_once_init_enter (&drt_rich_text_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtRichTextViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_rich_text_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtRichTextView), 0, (GInstanceInitFunc) drt_rich_text_view_instance_init, NULL };
		GType drt_rich_text_view_type_id;
		drt_rich_text_view_type_id = g_type_register_static (gtk_text_view_get_type (), "DrtRichTextView", &g_define_type_info, 0);
		g_once_init_leave (&drt_rich_text_view_type_id__volatile, drt_rich_text_view_type_id);
	}
	return drt_rich_text_view_type_id__volatile;
}


static void _vala_drt_rich_text_view_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtRichTextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RICH_TEXT_VIEW, DrtRichTextView);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_rich_text_view_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtRichTextView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_RICH_TEXT_VIEW, DrtRichTextView);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



