/* SocketChannel.c generated by valac 0.34.9, the Vala compiler
 * generated from SocketChannel.vala, do not modify */

/*
 * Copyright 2014-2016 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gunixsocketaddress.h>


#define DRT_TYPE_DUPLEX_CHANNEL (drt_duplex_channel_get_type ())
#define DRT_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannel))
#define DRT_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))
#define DRT_IS_DUPLEX_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_IS_DUPLEX_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_DUPLEX_CHANNEL))
#define DRT_DUPLEX_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_DUPLEX_CHANNEL, DrtDuplexChannelClass))

typedef struct _DrtDuplexChannel DrtDuplexChannel;
typedef struct _DrtDuplexChannelClass DrtDuplexChannelClass;
typedef struct _DrtDuplexChannelPrivate DrtDuplexChannelPrivate;

#define DRT_TYPE_SOCKET_CHANNEL (drt_socket_channel_get_type ())
#define DRT_SOCKET_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannel))
#define DRT_SOCKET_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannelClass))
#define DRT_IS_SOCKET_CHANNEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DRT_TYPE_SOCKET_CHANNEL))
#define DRT_IS_SOCKET_CHANNEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), DRT_TYPE_SOCKET_CHANNEL))
#define DRT_SOCKET_CHANNEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannelClass))

typedef struct _DrtSocketChannel DrtSocketChannel;
typedef struct _DrtSocketChannelClass DrtSocketChannelClass;
typedef struct _DrtSocketChannelPrivate DrtSocketChannelPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_source_unref0(var) ((var == NULL) ? NULL : (var = (g_source_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _DrtDuplexChannel {
	GObject parent_instance;
	DrtDuplexChannelPrivate * priv;
};

struct _DrtDuplexChannelClass {
	GObjectClass parent_class;
	void (*close) (DrtDuplexChannel* self, GError** error);
};

struct _DrtSocketChannel {
	DrtDuplexChannel parent_instance;
	DrtSocketChannelPrivate * priv;
};

struct _DrtSocketChannelClass {
	DrtDuplexChannelClass parent_class;
};

struct _DrtSocketChannelPrivate {
	GSocketConnection* _connection;
	gboolean _can_read;
	gboolean _can_write;
	GSource* socket_source;
};

typedef enum  {
	DRT_IO_ERROR_CONN_FAILED,
	DRT_IO_ERROR_TIMEOUT,
	DRT_IO_ERROR_RW_FAILED,
	DRT_IO_ERROR_READ,
	DRT_IO_ERROR_WRITE,
	DRT_IO_ERROR_TOO_MANY_DATA,
	DRT_IO_ERROR_NOT_CONNECTED,
	DRT_IO_ERROR_OP_FAILED
} DrtIOError;
#define DRT_IO_ERROR drt_io_error_quark ()

static gpointer drt_socket_channel_parent_class = NULL;

GType drt_duplex_channel_get_type (void) G_GNUC_CONST;
GType drt_socket_channel_get_type (void) G_GNUC_CONST;
#define DRT_SOCKET_CHANNEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannelPrivate))
enum  {
	DRT_SOCKET_CHANNEL_DUMMY_PROPERTY,
	DRT_SOCKET_CHANNEL_CONNECTION,
	DRT_SOCKET_CHANNEL_CAN_READ,
	DRT_SOCKET_CHANNEL_CAN_WRITE
};
GSocketConnection* drt_socket_channel_get_connection (DrtSocketChannel* self);
static void drt_socket_channel_on_connection_closed (DrtSocketChannel* self, GObject* o, GParamSpec* p);
static void _drt_socket_channel_on_connection_closed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
GSocketConnection* drt_socket_channel_create_socket_from_name (const gchar* name, GError** error);
gchar* drt_ipc_create_path (const gchar* name);
DrtSocketChannel* drt_socket_channel_new (guint id, const gchar* name, GSocketConnection* connection, guint timeout);
DrtSocketChannel* drt_socket_channel_construct (GType object_type, guint id, const gchar* name, GSocketConnection* connection, guint timeout);
DrtDuplexChannel* drt_duplex_channel_construct (GType object_type, guint id, const gchar* name, GInputStream* input, GOutputStream* output, guint timeout);
static void drt_socket_channel_set_connection (DrtSocketChannel* self, GSocketConnection* value);
static gboolean drt_socket_channel_on_socket_source (DrtSocketChannel* self, GSocket* socket, GIOCondition condition);
static gboolean _drt_socket_channel_on_socket_source_gsocket_source_func (GSocket* socket, GIOCondition condition, gpointer self);
static void drt_socket_channel_check_io_condition (DrtSocketChannel* self);
GQuark drt_io_error_quark (void);
DrtSocketChannel* drt_socket_channel_new_from_name (guint id, const gchar* name, guint timeout, GError** error);
DrtSocketChannel* drt_socket_channel_construct_from_name (GType object_type, guint id, const gchar* name, guint timeout, GError** error);
DrtSocketChannel* drt_socket_channel_new_from_socket (guint id, GSocket* socket, guint timeout, GError** error);
DrtSocketChannel* drt_socket_channel_construct_from_socket (GType object_type, guint id, GSocket* socket, guint timeout, GError** error);
static void drt_socket_channel_real_close (DrtDuplexChannel* base, GError** error);
void drt_duplex_channel_set_closed (DrtDuplexChannel* self, gboolean value);
static void drt_socket_channel_set_condition (DrtSocketChannel* self, GIOCondition condition);
gboolean drt_flags_is_set (gint value, gint flag);
gboolean drt_socket_channel_get_can_read (DrtSocketChannel* self);
static void drt_socket_channel_set_can_read (DrtSocketChannel* self, gboolean value);
gboolean drt_socket_channel_get_can_write (DrtSocketChannel* self);
static void drt_socket_channel_set_can_write (DrtSocketChannel* self, gboolean value);
gboolean drt_duplex_channel_get_closed (DrtDuplexChannel* self);
static void drt_socket_channel_finalize (GObject* obj);
static void _vala_drt_socket_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_drt_socket_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _drt_socket_channel_on_connection_closed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	drt_socket_channel_on_connection_closed ((DrtSocketChannel*) self, _sender, pspec);
}


GSocketConnection* drt_socket_channel_create_socket_from_name (const gchar* name, GError** error) {
	GSocketConnection* result = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GUnixSocketAddress* address = NULL;
	const gchar* _tmp2_ = NULL;
	GUnixSocketAddress* _tmp3_ = NULL;
	GSocket* socket = NULL;
	GSocket* _tmp4_ = NULL;
	GSocketConnection* connection = NULL;
	GSocket* _tmp5_ = NULL;
	GSocketConnection* _tmp6_ = NULL;
	GSocketConnection* _tmp7_ = NULL;
	GUnixSocketAddress* _tmp8_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp1_ = drt_ipc_create_path (_tmp0_);
	path = _tmp1_;
	_tmp2_ = path;
	_tmp3_ = (GUnixSocketAddress*) g_unix_socket_address_new (_tmp2_);
	address = _tmp3_;
	_tmp4_ = g_socket_new (G_SOCKET_FAMILY_UNIX, G_SOCKET_TYPE_STREAM, G_SOCKET_PROTOCOL_DEFAULT, &_inner_error_);
	socket = _tmp4_;
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (address);
		_g_free0 (path);
		return NULL;
	}
	_tmp5_ = socket;
	_tmp6_ = g_socket_connection_factory_create_connection (_tmp5_);
	connection = _tmp6_;
	_tmp7_ = connection;
	_tmp8_ = address;
	g_socket_connection_connect (_tmp7_, (GSocketAddress*) _tmp8_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_propagate_error (error, _inner_error_);
		_g_object_unref0 (connection);
		_g_object_unref0 (socket);
		_g_object_unref0 (address);
		_g_free0 (path);
		return NULL;
	}
	result = connection;
	_g_object_unref0 (socket);
	_g_object_unref0 (address);
	_g_free0 (path);
	return result;
}


static gboolean _drt_socket_channel_on_socket_source_gsocket_source_func (GSocket* socket, GIOCondition condition, gpointer self) {
	gboolean result;
	result = drt_socket_channel_on_socket_source ((DrtSocketChannel*) self, socket, condition);
	return result;
}


DrtSocketChannel* drt_socket_channel_construct (GType object_type, guint id, const gchar* name, GSocketConnection* connection, guint timeout) {
	DrtSocketChannel * self = NULL;
	guint _tmp0_ = 0U;
	const gchar* _tmp1_ = NULL;
	GSocketConnection* _tmp2_ = NULL;
	GInputStream* _tmp3_ = NULL;
	GInputStream* _tmp4_ = NULL;
	GSocketConnection* _tmp5_ = NULL;
	GOutputStream* _tmp6_ = NULL;
	GOutputStream* _tmp7_ = NULL;
	guint _tmp8_ = 0U;
	GSocketConnection* _tmp9_ = NULL;
	GSocketConnection* _tmp10_ = NULL;
	GSocket* _tmp11_ = NULL;
	GSocket* _tmp12_ = NULL;
	GSource* _tmp13_ = NULL;
	GSource* _tmp14_ = NULL;
	GSocketConnection* _tmp15_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (connection != NULL, NULL);
	_tmp0_ = id;
	_tmp1_ = name;
	_tmp2_ = connection;
	_tmp3_ = g_io_stream_get_input_stream ((GIOStream*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = connection;
	_tmp6_ = g_io_stream_get_output_stream ((GIOStream*) _tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = timeout;
	self = (DrtSocketChannel*) drt_duplex_channel_construct (object_type, _tmp0_, _tmp1_, _tmp4_, _tmp7_, _tmp8_);
	_tmp9_ = connection;
	drt_socket_channel_set_connection (self, _tmp9_);
	_tmp10_ = connection;
	_tmp11_ = g_socket_connection_get_socket (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_socket_create_source (_tmp12_, G_IO_IN | G_IO_OUT, NULL);
	_g_source_unref0 (self->priv->socket_source);
	self->priv->socket_source = _tmp13_;
	_tmp14_ = self->priv->socket_source;
	g_source_set_callback (_tmp14_, (GSourceFunc) _drt_socket_channel_on_socket_source_gsocket_source_func, g_object_ref (self), g_object_unref);
	drt_socket_channel_check_io_condition (self);
	_tmp15_ = connection;
	g_signal_connect_object ((GObject*) _tmp15_, "notify::closed", (GCallback) _drt_socket_channel_on_connection_closed_g_object_notify, self, G_CONNECT_AFTER);
	return self;
}


DrtSocketChannel* drt_socket_channel_new (guint id, const gchar* name, GSocketConnection* connection, guint timeout) {
	return drt_socket_channel_construct (DRT_TYPE_SOCKET_CHANNEL, id, name, connection, timeout);
}


DrtSocketChannel* drt_socket_channel_construct_from_name (GType object_type, guint id, const gchar* name, guint timeout, GError** error) {
	DrtSocketChannel * self = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (name != NULL, NULL);
	{
		GSocketConnection* connection = NULL;
		const gchar* _tmp0_ = NULL;
		GSocketConnection* _tmp1_ = NULL;
		guint _tmp2_ = 0U;
		const gchar* _tmp3_ = NULL;
		GSocketConnection* _tmp4_ = NULL;
		guint _tmp5_ = 0U;
		_tmp0_ = name;
		_tmp1_ = drt_socket_channel_create_socket_from_name (_tmp0_, &_inner_error_);
		connection = _tmp1_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch51_g_error;
		}
		_tmp2_ = id;
		_tmp3_ = name;
		_tmp4_ = connection;
		_tmp5_ = timeout;
		self = (DrtSocketChannel*) drt_socket_channel_construct (object_type, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
		_g_object_unref0 (connection);
	}
	goto __finally51;
	__catch51_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_ = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp6_ = name;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = g_error_new (DRT_IO_ERROR, DRT_IO_ERROR_CONN_FAILED, "Failed to connect to socket '%s'. %s", _tmp6_, _tmp8_);
		_inner_error_ = _tmp9_;
		_g_error_free0 (e);
		goto __finally51;
	}
	__finally51:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (self);
			return NULL;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	return self;
}


DrtSocketChannel* drt_socket_channel_new_from_name (guint id, const gchar* name, guint timeout, GError** error) {
	return drt_socket_channel_construct_from_name (DRT_TYPE_SOCKET_CHANNEL, id, name, timeout, error);
}


DrtSocketChannel* drt_socket_channel_construct_from_socket (GType object_type, guint id, GSocket* socket, guint timeout, GError** error) {
	DrtSocketChannel * self = NULL;
	gchar* name = NULL;
	GSocket* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar* _tmp2_ = NULL;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (socket != NULL, NULL);
	_tmp0_ = socket;
	_tmp1_ = g_socket_get_fd (_tmp0_);
	_tmp2_ = g_strdup_printf ("fd:%d", _tmp1_);
	name = _tmp2_;
	{
		GSocketConnection* connection = NULL;
		GSocket* _tmp3_ = NULL;
		GSocketConnection* _tmp4_ = NULL;
		guint _tmp5_ = 0U;
		guint _tmp6_ = 0U;
		_tmp3_ = socket;
		_tmp4_ = g_socket_connection_factory_create_connection (_tmp3_);
		connection = _tmp4_;
		_tmp5_ = id;
		_tmp6_ = timeout;
		self = (DrtSocketChannel*) drt_socket_channel_construct (object_type, _tmp5_, name, connection, _tmp6_);
		_g_object_unref0 (connection);
	}
	goto __finally52;
	__catch52_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		GError* _tmp9_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		_tmp9_ = g_error_new (DRT_IO_ERROR, DRT_IO_ERROR_CONN_FAILED, "Failed to connect to socket '%s'. %s", name, _tmp8_);
		_inner_error_ = _tmp9_;
		_g_error_free0 (e);
		goto __finally52;
	}
	__finally52:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == DRT_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			_g_free0 (name);
			_g_object_unref0 (self);
			return NULL;
		} else {
			_g_free0 (name);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_g_free0 (name);
	return self;
}


DrtSocketChannel* drt_socket_channel_new_from_socket (guint id, GSocket* socket, guint timeout, GError** error) {
	return drt_socket_channel_construct_from_socket (DRT_TYPE_SOCKET_CHANNEL, id, socket, timeout, error);
}


static void drt_socket_channel_real_close (DrtDuplexChannel* base, GError** error) {
	DrtSocketChannel * self;
	GSocketConnection* _tmp0_ = NULL;
	GError * _inner_error_ = NULL;
	self = (DrtSocketChannel*) base;
	drt_duplex_channel_set_closed ((DrtDuplexChannel*) self, TRUE);
	_tmp0_ = self->priv->_connection;
	g_io_stream_close ((GIOStream*) _tmp0_, NULL, &_inner_error_);
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		if (_inner_error_->domain == G_IO_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static void drt_socket_channel_check_io_condition (DrtSocketChannel* self) {
	GIOCondition condition = 0;
	GSocketConnection* _tmp0_ = NULL;
	GSocket* _tmp1_ = NULL;
	GSocket* _tmp2_ = NULL;
	GIOCondition _tmp3_ = 0;
	GSource* _tmp4_ = NULL;
	GMainContext* _tmp5_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_connection;
	_tmp1_ = g_socket_connection_get_socket (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_socket_condition_check (_tmp2_, G_IO_IN | G_IO_OUT);
	condition = _tmp3_;
	drt_socket_channel_set_condition (self, condition);
	_tmp4_ = self->priv->socket_source;
	_tmp5_ = g_main_context_default ();
	g_source_attach (_tmp4_, _tmp5_);
}


static void drt_socket_channel_set_condition (DrtSocketChannel* self, GIOCondition condition) {
	gboolean read = FALSE;
	GIOCondition _tmp0_ = 0;
	gboolean _tmp1_ = FALSE;
	gboolean write = FALSE;
	GIOCondition _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = condition;
	_tmp1_ = drt_flags_is_set ((gint) _tmp0_, (gint) G_IO_IN);
	read = _tmp1_;
	_tmp2_ = condition;
	_tmp3_ = drt_flags_is_set ((gint) _tmp2_, (gint) G_IO_OUT);
	write = _tmp3_;
	_tmp4_ = self->priv->_can_read;
	_tmp5_ = read;
	if (_tmp4_ != _tmp5_) {
		gboolean _tmp6_ = FALSE;
		_tmp6_ = read;
		drt_socket_channel_set_can_read (self, _tmp6_);
	}
	_tmp7_ = self->priv->_can_write;
	_tmp8_ = write;
	if (_tmp7_ != _tmp8_) {
		gboolean _tmp9_ = FALSE;
		_tmp9_ = write;
		drt_socket_channel_set_can_write (self, _tmp9_);
	}
}


static gboolean drt_socket_channel_on_socket_source (DrtSocketChannel* self, GSocket* socket, GIOCondition condition) {
	gboolean result = FALSE;
	GIOCondition _tmp0_ = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (socket != NULL, FALSE);
	_tmp0_ = condition;
	drt_socket_channel_set_condition (self, _tmp0_);
	result = FALSE;
	return result;
}


static void drt_socket_channel_on_connection_closed (DrtSocketChannel* self, GObject* o, GParamSpec* p) {
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GSocketConnection* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (o != NULL);
	g_return_if_fail (p != NULL);
	_tmp0_ = drt_duplex_channel_get_closed ((DrtDuplexChannel*) self);
	_tmp1_ = _tmp0_;
	_tmp2_ = self->priv->_connection;
	g_object_get ((GIOStream*) _tmp2_, "closed", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	if (_tmp1_ != _tmp4_) {
		GSocketConnection* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_ = FALSE;
		_tmp5_ = self->priv->_connection;
		g_object_get ((GIOStream*) _tmp5_, "closed", &_tmp6_, NULL);
		_tmp7_ = _tmp6_;
		drt_duplex_channel_set_closed ((DrtDuplexChannel*) self, _tmp7_);
	}
}


GSocketConnection* drt_socket_channel_get_connection (DrtSocketChannel* self) {
	GSocketConnection* result;
	GSocketConnection* _tmp0_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_connection;
	result = _tmp0_;
	return result;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void drt_socket_channel_set_connection (DrtSocketChannel* self, GSocketConnection* value) {
	GSocketConnection* _tmp0_ = NULL;
	GSocketConnection* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (self->priv->_connection);
	self->priv->_connection = _tmp1_;
	g_object_notify ((GObject *) self, "connection");
}


gboolean drt_socket_channel_get_can_read (DrtSocketChannel* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_read;
	result = _tmp0_;
	return result;
}


static void drt_socket_channel_set_can_read (DrtSocketChannel* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_read = _tmp0_;
	g_object_notify ((GObject *) self, "can-read");
}


gboolean drt_socket_channel_get_can_write (DrtSocketChannel* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_can_write;
	result = _tmp0_;
	return result;
}


static void drt_socket_channel_set_can_write (DrtSocketChannel* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	self->priv->_can_write = _tmp0_;
	g_object_notify ((GObject *) self, "can-write");
}


static void drt_socket_channel_class_init (DrtSocketChannelClass * klass) {
	drt_socket_channel_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (DrtSocketChannelPrivate));
	((DrtDuplexChannelClass *) klass)->close = (void (*)(DrtDuplexChannel*, GError**)) drt_socket_channel_real_close;
	G_OBJECT_CLASS (klass)->get_property = _vala_drt_socket_channel_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_drt_socket_channel_set_property;
	G_OBJECT_CLASS (klass)->finalize = drt_socket_channel_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_SOCKET_CHANNEL_CONNECTION, g_param_spec_object ("connection", "connection", "connection", g_socket_connection_get_type (), G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_SOCKET_CHANNEL_CAN_READ, g_param_spec_boolean ("can-read", "can-read", "can-read", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DRT_SOCKET_CHANNEL_CAN_WRITE, g_param_spec_boolean ("can-write", "can-write", "can-write", FALSE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
}


static void drt_socket_channel_instance_init (DrtSocketChannel * self) {
	self->priv = DRT_SOCKET_CHANNEL_GET_PRIVATE (self);
	self->priv->_can_read = FALSE;
	self->priv->_can_write = FALSE;
}


static void drt_socket_channel_finalize (GObject* obj) {
	DrtSocketChannel * self;
	GSocketConnection* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	GQuark _tmp2_ = 0U;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannel);
	_tmp0_ = self->priv->_connection;
	g_signal_parse_name ("notify::closed", G_TYPE_OBJECT, &_tmp1_, &_tmp2_, TRUE);
	g_signal_handlers_disconnect_matched ((GObject*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, _tmp2_, NULL, (GCallback) _drt_socket_channel_on_connection_closed_g_object_notify, self);
	_g_object_unref0 (self->priv->_connection);
	_g_source_unref0 (self->priv->socket_source);
	G_OBJECT_CLASS (drt_socket_channel_parent_class)->finalize (obj);
}


GType drt_socket_channel_get_type (void) {
	static volatile gsize drt_socket_channel_type_id__volatile = 0;
	if (g_once_init_enter (&drt_socket_channel_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DrtSocketChannelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) drt_socket_channel_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DrtSocketChannel), 0, (GInstanceInitFunc) drt_socket_channel_instance_init, NULL };
		GType drt_socket_channel_type_id;
		drt_socket_channel_type_id = g_type_register_static (DRT_TYPE_DUPLEX_CHANNEL, "DrtSocketChannel", &g_define_type_info, 0);
		g_once_init_leave (&drt_socket_channel_type_id__volatile, drt_socket_channel_type_id);
	}
	return drt_socket_channel_type_id__volatile;
}


static void _vala_drt_socket_channel_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DrtSocketChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannel);
	switch (property_id) {
		case DRT_SOCKET_CHANNEL_CONNECTION:
		g_value_set_object (value, drt_socket_channel_get_connection (self));
		break;
		case DRT_SOCKET_CHANNEL_CAN_READ:
		g_value_set_boolean (value, drt_socket_channel_get_can_read (self));
		break;
		case DRT_SOCKET_CHANNEL_CAN_WRITE:
		g_value_set_boolean (value, drt_socket_channel_get_can_write (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_drt_socket_channel_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DrtSocketChannel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DRT_TYPE_SOCKET_CHANNEL, DrtSocketChannel);
	switch (property_id) {
		case DRT_SOCKET_CHANNEL_CONNECTION:
		drt_socket_channel_set_connection (self, g_value_get_object (value));
		break;
		case DRT_SOCKET_CHANNEL_CAN_READ:
		drt_socket_channel_set_can_read (self, g_value_get_boolean (value));
		break;
		case DRT_SOCKET_CHANNEL_CAN_WRITE:
		drt_socket_channel_set_can_write (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



