/* X11.c generated by valac 0.34.9, the Vala compiler
 * generated from X11.vala, do not modify */

/*
 * Copyright 2015 Jiří Janoušek <janousek.jiri@gmail.com>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * 1. Redistributions of source code must retain the above copyright notice, this
 *    list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



GdkX11Window* drt_x11_get_window_property_as_win (GdkWindow* window, const gchar* property);
gchar* drt_x11_get_window_property_as_utf8 (GdkWindow* window, const gchar* property);
GdkX11Window* drt_x11_get_net_wm_check_window (void);


/**
 * Retrieve window property of type window.
 * 
 * @param window      target window or ``null`` to use the default root window
 * @param property    name of the requested property
 * @return            the value of property as {@link Gdk.X11.Window} on success,
 *                    null on failure such as invalid ``window``, non-existent ``property``
 *                    or different property type than {@link X.XA_WINDOW}.
 */
static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


GdkX11Window* drt_x11_get_window_property_as_win (GdkWindow* window, const gchar* property) {
	GdkX11Window* result = NULL;
	GdkX11Window* win = NULL;
	GdkX11Window* _result_ = NULL;
	GdkWindow* _tmp0_ = NULL;
	GdkX11Display* display = NULL;
	GdkX11Window* _tmp5_ = NULL;
	GdkDisplay* _tmp6_ = NULL;
	GdkX11Display* _tmp7_ = NULL;
	Atom type = {0};
	gint format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	GdkX11Display* _tmp8_ = NULL;
	GdkX11Display* _tmp9_ = NULL;
	Display* _tmp10_ = NULL;
	GdkX11Window* _tmp11_ = NULL;
	Window _tmp12_ = 0;
	GdkX11Display* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	Atom _tmp15_ = {0};
	Atom _tmp16_ = {0};
	gint _tmp17_ = 0;
	gulong _tmp18_ = 0UL;
	gulong _tmp19_ = 0UL;
	void* _tmp20_ = NULL;
	GdkX11Display* _tmp21_ = NULL;
	Atom _tmp22_ = {0};
	void* _tmp27_ = NULL;
	g_return_val_if_fail (property != NULL, NULL);
	_result_ = NULL;
	_tmp0_ = window;
	if (_tmp0_ != NULL) {
		GdkWindow* _tmp1_ = NULL;
		GdkX11Window* _tmp2_ = NULL;
		_tmp1_ = window;
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp1_) : NULL);
		_g_object_unref0 (win);
		win = _tmp2_;
	} else {
		GdkWindow* _tmp3_ = NULL;
		GdkX11Window* _tmp4_ = NULL;
		_tmp3_ = gdk_get_default_root_window ();
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp3_) : NULL);
		_g_object_unref0 (win);
		win = _tmp4_;
	}
	_tmp5_ = win;
	_tmp6_ = gdk_window_get_display ((GdkWindow*) _tmp5_);
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp6_) : NULL);
	display = _tmp7_;
	_tmp8_ = display;
	gdk_x11_display_error_trap_push (_tmp8_);
	_tmp9_ = display;
	_tmp10_ = gdk_x11_display_get_xdisplay (_tmp9_);
	_tmp11_ = win;
	_tmp12_ = gdk_x11_window_get_xid (_tmp11_);
	_tmp13_ = display;
	_tmp14_ = property;
	_tmp15_ = gdk_x11_get_xatom_by_name_for_display (_tmp13_, _tmp14_);
	XGetWindowProperty (_tmp10_, _tmp12_, _tmp15_, (glong) 0, G_MAXLONG, FALSE, XA_WINDOW, &_tmp16_, &_tmp17_, &_tmp18_, &_tmp19_, (unsigned char **) (&_tmp20_));
	type = _tmp16_;
	format = _tmp17_;
	n_items = _tmp18_;
	bytes_after = _tmp19_;
	data = _tmp20_;
	_tmp21_ = display;
	gdk_x11_display_error_trap_pop_ignored (_tmp21_);
	_tmp22_ = type;
	if (_tmp22_ == XA_WINDOW) {
		Window xwin = 0;
		void* _tmp23_ = NULL;
		GdkX11Display* _tmp24_ = NULL;
		Window _tmp25_ = 0;
		GdkX11Window* _tmp26_ = NULL;
		_tmp23_ = data;
		xwin = *((Window*) _tmp23_);
		_tmp24_ = display;
		_tmp25_ = xwin;
		_tmp26_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (_tmp24_, _tmp25_);
		_g_object_unref0 (_result_);
		_result_ = _tmp26_;
	}
	_tmp27_ = data;
	if (_tmp27_ != NULL) {
		void* _tmp28_ = NULL;
		_tmp28_ = data;
		XFree (_tmp28_);
	}
	result = _result_;
	_g_object_unref0 (display);
	_g_object_unref0 (win);
	return result;
}


/**
 * Retrieve window property of type UTF-8 string.
 * 
 * @param window      target window or ``null`` to use the default root window
 * @param property    name of the requested property
 * @return            the value of property as string on success,
 *                    null on failure such as invalid ``window`` or non-existent ``property``.
 */
gchar* drt_x11_get_window_property_as_utf8 (GdkWindow* window, const gchar* property) {
	gchar* result = NULL;
	GdkX11Window* win = NULL;
	GdkWindow* _tmp0_ = NULL;
	GdkX11Display* display = NULL;
	GdkX11Window* _tmp5_ = NULL;
	GdkDisplay* _tmp6_ = NULL;
	GdkX11Display* _tmp7_ = NULL;
	Atom type = {0};
	gint format = 0;
	gulong n_items = 0UL;
	gulong bytes_after = 0UL;
	void* data = NULL;
	gchar* name = NULL;
	GdkX11Display* _tmp8_ = NULL;
	GdkX11Display* _tmp9_ = NULL;
	Display* _tmp10_ = NULL;
	GdkX11Window* _tmp11_ = NULL;
	Window _tmp12_ = 0;
	GdkX11Display* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	Atom _tmp15_ = {0};
	GdkX11Display* _tmp16_ = NULL;
	Atom _tmp17_ = {0};
	Atom _tmp18_ = {0};
	gint _tmp19_ = 0;
	gulong _tmp20_ = 0UL;
	gulong _tmp21_ = 0UL;
	void* _tmp22_ = NULL;
	GdkX11Display* _tmp23_ = NULL;
	void* _tmp24_ = NULL;
	g_return_val_if_fail (property != NULL, NULL);
	_tmp0_ = window;
	if (_tmp0_ != NULL) {
		GdkWindow* _tmp1_ = NULL;
		GdkX11Window* _tmp2_ = NULL;
		_tmp1_ = window;
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp1_) : NULL);
		_g_object_unref0 (win);
		win = _tmp2_;
	} else {
		GdkWindow* _tmp3_ = NULL;
		GdkX11Window* _tmp4_ = NULL;
		_tmp3_ = gdk_get_default_root_window ();
		_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gdk_x11_window_get_type ()) ? ((GdkX11Window*) _tmp3_) : NULL);
		_g_object_unref0 (win);
		win = _tmp4_;
	}
	_tmp5_ = win;
	_tmp6_ = gdk_window_get_display ((GdkWindow*) _tmp5_);
	_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, gdk_x11_display_get_type ()) ? ((GdkX11Display*) _tmp6_) : NULL);
	display = _tmp7_;
	name = NULL;
	_tmp8_ = display;
	gdk_x11_display_error_trap_push (_tmp8_);
	_tmp9_ = display;
	_tmp10_ = gdk_x11_display_get_xdisplay (_tmp9_);
	_tmp11_ = win;
	_tmp12_ = gdk_x11_window_get_xid (_tmp11_);
	_tmp13_ = display;
	_tmp14_ = property;
	_tmp15_ = gdk_x11_get_xatom_by_name_for_display (_tmp13_, _tmp14_);
	_tmp16_ = display;
	_tmp17_ = gdk_x11_get_xatom_by_name_for_display (_tmp16_, "UTF8_STRING");
	XGetWindowProperty (_tmp10_, _tmp12_, _tmp15_, (glong) 0, G_MAXLONG, FALSE, _tmp17_, &_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_, (unsigned char **) (&_tmp22_));
	type = _tmp18_;
	format = _tmp19_;
	n_items = _tmp20_;
	bytes_after = _tmp21_;
	data = _tmp22_;
	_tmp23_ = display;
	gdk_x11_display_error_trap_pop_ignored (_tmp23_);
	_tmp24_ = data;
	if (_tmp24_ != NULL) {
		void* _tmp25_ = NULL;
		gchar* _tmp26_ = NULL;
		void* _tmp27_ = NULL;
		_tmp25_ = data;
		_tmp26_ = g_strdup ((const gchar*) _tmp25_);
		_g_free0 (name);
		name = _tmp26_;
		_tmp27_ = data;
		XFree (_tmp27_);
	}
	result = name;
	_g_object_unref0 (display);
	_g_object_unref0 (win);
	return result;
}


/**
 * Retrieve WM_CHECK Window of a compliant window manager
 * 
 * See [[http://standards.freedesktop.org/wm-spec/1.3/ar01s03.html|Extended Window Manager Hints]].
 * 
 * @return    WM_CHECK Window of a compliant window manager of null if there is not any
 */
GdkX11Window* drt_x11_get_net_wm_check_window (void) {
	GdkX11Window* result = NULL;
	GdkX11Window* window = NULL;
	GdkX11Window* _tmp0_ = NULL;
	GdkX11Window* _tmp1_ = NULL;
	GdkX11Window* _tmp2_ = NULL;
	GdkX11Window* _tmp3_ = NULL;
	GdkX11Window* _tmp4_ = NULL;
	Window _tmp5_ = 0;
	GdkX11Window* _tmp6_ = NULL;
	Window _tmp7_ = 0;
	gboolean _tmp8_ = FALSE;
	_tmp0_ = drt_x11_get_window_property_as_win (NULL, "_NET_SUPPORTING_WM_CHECK");
	window = _tmp0_;
	_tmp1_ = window;
	if (_tmp1_ == NULL) {
		result = NULL;
		_g_object_unref0 (window);
		return result;
	}
	_tmp2_ = window;
	_tmp3_ = drt_x11_get_window_property_as_win ((GdkWindow*) _tmp2_, "_NET_SUPPORTING_WM_CHECK");
	_tmp4_ = _tmp3_;
	_tmp5_ = gdk_x11_window_get_xid (_tmp4_);
	_tmp6_ = window;
	_tmp7_ = gdk_x11_window_get_xid (_tmp6_);
	_tmp8_ = _tmp5_ != _tmp7_;
	_g_object_unref0 (_tmp4_);
	if (_tmp8_) {
		result = NULL;
		_g_object_unref0 (window);
		return result;
	}
	result = window;
	return result;
}



